# History

- Tera Term
- TTSSH
- CygTerm+
- cyglaunch
- TTProxy
- TeraTerm Menu
- TTX KanjiMenu
- TTXAlwaysOnTop
- TTXKCodeChange
- TTXResizeMenu
- TTXttyrec
- TTXViewMode
- TTXRecurringCommand

## Tera Term

### YYYY.MM.DD (Ver 5.1, not yet released)

- Bug fixes
  - MACRO: strjoin command set concatenated string to the wrong variable.

### 2023.10.15 (Ver 5.0)

- Changes
  - Changed internal processing to Unicode.
  - Changed the folders to read setup files, the folder to save log files.
  - Changed default to on for High DPI support.
    - Same behavior as before the change when DPIAware=off add to Tera Term section in TERATERM.INI
  - Added setting Underline attribute(SGR 4) color and font
  - if log file name from command line or default log file name is not full path, now it is considered as relative path from log folder or default log save folder.
  - Exchanged foreground and background colors of characters that attributes is setted ANSIColor when colors are reversed with DECSCNM set.
  - U+00A0(NBSP) and U+2000..U+2003 are converted to SPACE and displayed. tree command output is displayed correctly.
  - XMODEM: Fix to check all received datas and process correctly, even if received datas are accumulated.
  - YMODEM: ignore continuous 'C' when waiting for sending.
  - Changed window position to specified in TERATERM.INI when duplicate a session.
  - added a setting that can disable corner rounding of VT Window and TEK Window in Windows 11.
    - added the WindowCornerDontround entry in the teraterm.ini file. The default is off.
  - changed behavior of Binary checkbox of Send file on file drop dialog.
    - now default state is TransBin value of TERATERM.INI.
    - now state is remembered when "Do same process, next drop" is checked.
  - Invalid characters as file name contains Default log file name, are replaced with '_'.
- Bug fixes
  - Fixed problem with color number 1-7 and 9-15 are replaced in sequence OCS 4.
  - Fixed wrong color numbers in the color change and response sequence.
  - Fixed the area selected with the mouse does not disappear when the text is erased with the erase escape sequences.
  - Reset text colors when [Control]-[Reset terminal] is selected
  - Fixed wrong window size is set when NAWS (Negotiate About Window Size) is received on telnet (cygterm) connection.
  - Fixed mouse cursor style is changed to hand when mouse cursor hover on URL string even when clickable URL is disabled.
  - Fixed DPI adjustment does not work correctly when VT Window is moved to different DPI monitor.
  - Fixed Kermit could not receive in some case.
  - Adjusted packet size of Kermit send.
  - Fixed full color icon is not used to notify icon.
  - Fixed changed custom notify icon is not used to notify icon.
  - Fixed when SSH connected, "Do same process, next drop" is checked on "File Drag and Drop" dialog, nevertheless always "SCP" is selected.
  - Fixed current font name was empty in ChooseFont dialog when changing dialog fonts.
  - Fixed wrong color numbers were changed when the color palette change in Visual Tab in Additional settings dialog.
  - Fixed "Send file" help is appear when "Help" button is pushed on Log dialog.
  - Fixed wrong value is written to VTReverseColor when saving TERATERM.INI during reverse video.
  - Fixed when setting value of MouseCursor in TERATERM.INI is lower case, value is not loaded to "Additional settings" dialog.
  - The file handle of TELNET.LOG could not be closed.
  - MACRO: can not read from the file handle that is opened by filecreate command. This bug was introduced in 4.102.
  - MACRO: The setpassword command cause an error when password argument is a string value. Only string variable was accepted.
  - MACRO: The getpassword command updates password variable by undefined value when password from user is no input.
- Misc
  - Changed requirements, Windows 7 or later.
  - Added about EAR (Export Administration Regulations) to Frequently asked questions.
  - Upgraded TTSSH to 3.0.
  - upgraded TeraTerm Menu to 1.17
  - upgraded TTXttyrec Plug-in to 1.05.
  - upgraded TTXResizeMenu Plug-in to 1.07.
  - NOTE: CygTerm+ binary included in the installer becomes to be supported on only 64bit Cygwin. Please build CygTerm+ from source code by using 32bit Cygwin, if CygTerm+ wants to run with 32bit Cygwin.
  - Deleted LogMeTT, TTLEditor and Collector.
  - upgraded Oniguruma to 6.9.8.

### 2021.6.5 (Ver 4.106)

- Changes
  - Increased max width of window from 500 to 1000 chars.
  - Serial port connection
    - Removed the 1.5 stop bit in the serial port setup.
    - Removed the "1.5" name from the StopBit entry in the teraterm.ini file.
- Bug fixes
  - The elapsed time style timestamp in the log is incorrect.
  - Fixed support for IME feedback back and forth function. This bug was introduced in 4.103.
  - Fixed an application fault occurs when VT Window and HtmlHelp Windows are closed at same time.
  - Fixed desktop images can not be displayed on background other than main display. This bug was introduced in 4.101.
  - Fixed memory leak when tool tip is shown. This bug was introduced in 4.103.
  - MACRO: the yesnobox command shows "OK" instead of "yes" without language file. This bug was introduced in 4.103.
  - MACRO: The file handle opened by filecreate, fileopen marco command is locking.
  - MACRO: When the getdate, gettime command is executed with timezone parameter, valid time may not be returned. Build mistaken in 4.105.
- Misc
  - upgraded TTSSH to 2.92.
  - upgraded TTX KanjiMenu Plug-in to 0.1.8
  - upgraded TeraTerm Menu to 1.16
  - upgraded Oniguruma to 6.9.7.1.

### 2019.12.7 (Ver 4.105)

- Changes
  - Added SFMT information on version dialog.
  - Changed of indication from "Protocol" to "IP version" and from "UNSPEC" to "AUTO" on New connection dialog.
  - When the opacity value of the window is temporarily changed by operating the mouse wheel on the title bar of VT window, the tooltip of the opacity value is shown.
  - The location of resizing tooltip is automatically moved to coordinates after resizing.
  - Added slider for specify the opacity values on the Visual tab of the Additional settings dialog. When transparency is not available, made opacity not changeable.
  - Eterm look-feel: Added the Mixed ThemeFile to Background configuration. Also, added the BGIgnoreThemeFile entry in the teraterm.ini file. The default value is off.
  - When the opacity values of the Additional settings dialog is input over than 255, the value is automatically changed to 255 over the dialog.
  - Added support for REP control sequence.
  - Added support for xterm ED 3 (clear scroll buffer) control sequence.
    - Added the "Accept clearing scroll buffer from remote" setting on the Control Sequence tab of the Additional settings dialog. The default value is off.
  - Added /OSC52= command line option for change the "Clipboard access from remote" setting.
  - Added the [Pause Logging] and the [Stop Logging] menu into the [File] menu.
  - The start of the text selection with the mouse can be delayed by setting.
    - Added the MouseSelectStartDelay entry in the teraterm.ini file. The default value is 0.
  - Serial port connection
    - Added support for hardware flow control DSR/DTR with serial connection.
      - The hardware is renamed to RTS/CTS, and DSR/DTR is newly added on the Flow control of Serial port ([Setup] menu).
      - MACRO: The DSR/DTR can be specified in setflowctrl command.
    - The [Setup]-[Serial port] dialog can be called even while TCP/IP connection.
    - The title of [Setup]-[Serial port] dialog is changed from "Serial port setup" to "Serial port setup and connection".
    - The detail information of COM port is added on the [Setup]-[Serial port] dialog.
    - The tooltip of the speed setting is added on the [Setup]-[Serial port] dialog.
    - The OK button notation in the [Setup]-[Serial port] dialog is changed referring to the connection state.
    - The OK button can not be pressed in the [Setup]-[Serial port] dialog when no COM ports are available.
    - Added /CDATABIT=, /CPARITY=, /CSTOPBIT=, /CFLOWCTRL=, /CDELAYPERCHAR=, /CDELAYPERLINE= command line options.
  - MACRO: When setdlgpos macro command has no argument, the dialog box is located on the default position.
  - MACRO: The dialog position specified by setdlgpos becomes to not be out of range in display.
- Bug fixes
  - The tooltip during resizing can not be displayed on the left and top edge of the desktop. This bug was introduced in 4.103.
  - Eterm look-feel: When an image file is randomly selected with the wallpaper, invalid file may be selected.
  - The help button of File-Log, File-Transfer, Setup-Font and Printer dialog does not work well. This bug was introduced in 4.104.
  - Fixed a problem that TTIMESV (Save IME status) / TTIMERS (Restore IME status) control sequences do not work.
  - The help button on the printer dialog can not be shown from Windows 2000 to 10. The help button on the printer dialog can be shown on all Windows except Windows95.
  - The macro window tries not to terminate when ESC key is pressed. This bug was introduced in 4.103.
  - Tera Term tries not to terminate when TEK window is closed. This bug was introduced in 4.103.
  - When the DPI is changed while menu bar hidden, the window size is correctly adjusted.
  - When DPI is changed, an application fault occurs on Windows 8.1.
  - The window title is garbled when receiving the window title setting control sequence which contains the kanji characters.
  - MACRO: The button of yesnobox selected with left or right arrow key is reversed.
  - The help button on the Save setup, Restore setup and Load key map dialog can not be shown.
  - Save setup dialog shows incorrectly "Open as read-only" check-box on Windows95/98/NT4.0.
  - MACRO: Error is displayed correctly when string constant is not terminated.
- Misc
  - Bug fix: A font(TSPECIAL1.TTF) copy may fail when Tera Term installs from the installer.
  - NOTE: CygTerm+ binary included in the installer becomes to be supported on Windows Vista or later. Please build CygTerm+'s source code by using Cygwin for older Windows, if CygTerm+ wants to run on older Windows.
  - upgraded TTSSH to 2.91.
  - upgraded TTProxy to 1.0.0.26.
  - upgraded TTXResizeMenu Plug-in to 1.06.
  - upgraded TTXttyrec Plug-in to 1.04.
  - Changed e-mail address of Contacting the author.

### 2019.08.31 (Ver 4.104)

- Changes
  - The Disabling text selection when the window is activated by mouse configuration can be set up on the Additional settings dialog.
  - The environment variable included in directory for file transfers becomes to be expanded.
  - Unspecified string font in IME uses your defined font.
  - Added help button on Additional settings dialog.
  - MACRO: The fileopen command does not cause an error when a file can not be opened. Reverted changes in 4.102.
  - MACRO: When filetruncate command does not cause an error when a file can not be opened, or file size can not be changed.
- Bug fixes
  - When UTF-8 characters received, 4-byte UTF-8 characters are miss-decoded.
  - When the Active Window Tracking is enabled, mouse cursor won't be active in Tera Term window. This bug was introduced in 4.103.
  - The session number of window title is always 1. This bug was introduced in 4.103.
  - When the font selection dialog is used while undetermined characters of IME are displayed , the font ot IME always is changed.
  - When the locale setting is default(japanese) or invalid on English version of Windows, an application fault immediately occurs after starting Tera Term.
  - A big file can not send by using [File]/[Send file..]. This bug was introduced in 4.103.
  - Cancel printing dialog can not be shown. This bug was introduced in 4.103.
  - The plugin compiled before 4.103 can not called because the DLL's calling convention is changed in Tera Term 4.103.
  - MACRO: listbox command can not adjust the width of list according to the window size. This bug was introduced in 4.103.
  - MACRO: filecopy command may not store the result to result system variable.
  - MACRO: filelock and fileunlock command always fail. This bug was introduced in 4.101.
  - MACRO: When the first byte of the file is matched by using filestrseek2 command, the file pointer is invalid. This bug was introduced in 4.101.
- Misc
  - upgraded TTSSH to 2.90.
  - upgraded TTProxy to 1.0.0.25.
  - upgraded Oniguruma to 6.9.3.

### 2019.06.15 (Ver 4.103)

- Changes
  - added support for High DPI experimentally.
    - The default setting is disabled. When DPIAware=on is set in [Tera Term] of teraterm.ini file, this feature is enabled.
    - However, this is only available for Windows 10 Version 1703 or later.
  - The font submenu is newly added, and added support for configure the dialog font.
    - The default font is same as before.
  - the pop-up menu of TEK Window is not displayed correctly.
  - When the font file(TSPECIAL1.TTF) displaying ruled line is not installed, the file is loaded from same directory as ttermpro.exe.
  - When the file sending by kermit protocol, notifies the file modification time instead of creation time.
  - MACRO: Store exec command result to result variable.
- Bug fixes
  - Display position of IME's conversion candidate window can not follow cursor position. This bug was introduced in 4.102.
  - Can't display character such as U+2014 EM DASH, U+2212 MINUS SIGN, U+301C WAVE DASH etc. This bug was introduced in 4.102.
  - MACRO: Fix handle leak when exec command is executed.
- Misc
  - upgraded TTSSH to 2.89.
  - upgraded Oniguruma to 6.9.2.

### 2019.02.28 (Ver 4.102)

- Changes
  - The AlphaBlend VT window can be configured as a different value for each active and inactive.
  - The value of transparency can be temporarily changed by moving the mouse wheel on the title bar of the VT window.
  - The internal implementation of the VT window was speeded up.
  - UTF-8: Four bytes character can not be shown yet but can be decoded, the impact range of character corruption was be minimized.
  - The language code(CodePage) of the "Terminal ([Setup] menu)" dialog(Unicode usage).
  - MACRO: The macro file can support UTF-8 and UTF-16(with BOM) encoding.
  - MACRO: The getfileattr command can be based on the current directory same as other command.
  - MACRO: The fileopen command can cause an error when a file is not found with read only mode.
- Bug fixes
  - When the AlphaBlend window is enabled, an application fault occurs on Windows 10.
- Misc
  - upgraded TTSSH to 2.88.
  - upgraded Oniguruma to 6.9.1.

### 2018.11.30 (Ver 4.101)

- Changes
  - added support for following dtterm window manipulation sequences.
    - 10: Full-screen mode
    - 13;2: Report window position. (text area)
    - 14;2: Report window size. (whole window)
    - 15: Report root window size in pixels.
    - 16: Report character size in pixels.
  - The behavior of following dtterm window manipulation sequence was changed.
    - 14: Report window size sequence: report text area size instead of whole window size.
  - The left and right margin mode does not be reset when window size is changed.
  - The `/' character can be treated as path separator by using the command line option receiving a file name.
- Bug fixes
  - The plugin compiled before 4.100 can not called because the DLL's calling convention is changed in Tera Term 4.100.
- Misc
  - upgraded TTSSH to 2.87.
  - upgraded TTXResizeMenu Plug-in to 1.05
  - upgraded Oniguruma to 6.9.0.

### 2018.08.31 (Ver 4.100)

- Changes
  - added support for multiple files' drag&drop.
  - Functional enhancement: Confirmation dialog by using drag&drop a file.
  - Window size is maximized when the title bar is double-clicked if "Term size = win size" setting is on.
  - added the Title format configuration on the General tab of the Additional settings dialog.
- Misc
  - upgraded TTSSH to 2.86.
  - upgraded TTXResizeMenu Plug-in to 1.04

### 2018.05.31 (Ver 4.99)

- Changes
  - added support for the DECSACE control sequence.
    - default affected area of DECCARA and DECRARA control sequence is changed to stream.
  - Improved the behavior of window resizing.
  - Accept service name instead of the port number on the command line option.
  - added the /SPEED= command line option which behavior is same as the /BAUD= command line option.
  - added the setspeed command.
- Bug fixes
  - When the mouse tracking is enabled, the menu can not be selected after clicking the screen.
  - The target area of the DECCARA (Change Attributes in Rectangular Area) and DECRARA (Reverse Attributes in Rectangular Area) control sequence is invalid.
  - The DECCARA control sequence breaks kanji character.
  - The DECCARA control sequence breaks the color of cells.
- Misc
  - upgraded TTSSH to 2.85.
  - upgraded Oniguruma to 6.8.2.

### 2018.02.28 (Ver 4.98)

- Bug fixes
  - The operability at screen edge is improved when mouse tracking is enabled.
- Misc
  - upgraded TTSSH to 2.84.
  - upgraded Oniguruma to 6.7.1.

### 2017.11.30 (Ver 4.97)

- Changes
  - The response of DA2 request is changed.
  - On telnet connection, the terminal speed is notified to the server.
    - added support for the Telnet Terminal Speed Option.
    - added the TerminalSpeed entry in the teraterm.ini file. The default is 38400.
  - added configuration of timestamp type at the start of log file's line.
    - added "Elapsed Time (Logging)" and "Elapsed Time (Connection)" as timestamp type.
    - The timestamp type can be changed on Log dialog and Additional settings dialog.
    - The LogTimestampUTC setting is obsolete, use the timestamp type setting instead.
- Bug fixes
  - The response of DECRQSS control sequence was invalid.
  - On telnet connection, the terminal size is not notified correctly if terminal width or height is 255.
  - When the [View Log] on the [File] is called, the editor does not invoked.
  - Fix the problem of the log option settings on the Log tab of Additional settings dialog
    - PlainText and Timestamp setting is not applied.
    - Changes to the log option settings are applied when the dialog is cancelled.
- Misc
  - upgraded TTSSH to 2.83.
  - upgraded TeraTerm Menu to 1.15
  - upgraded Oniguruma to 6.6.1.

### 2017.08.31 (Ver 4.96)

- Changes
  - added support for the configuring of the permitted ISO/IEC 2022 shift functions.
    - added the ISO2022ShiftFunction entry in the teraterm.ini file. The default is on.
  - added configuration of timestamp format at the start of log file's line.
    - added the LogTimestampFormat entry in the teraterm.ini file. The default is "%a %b %e %H:%M:%S.%N %Y".
    - The default format is changed to RFC 3339 style. Specify the "%a %b %e %H:%M:%S.%N %Y" at the LogTimestampFormat entry to restore before format.
  - UTC can be used at timestamp format at the start of log file's line.
    - added the LogTimestampUTC entry in the teraterm.ini file. The default is off.
  - Hidden font set by OS can be selected with font setting dialog.
    - The setting can be configured on the General tab of Additional settings dialog.
  - When the serial port and named pipe can not be opened, the error message contains reason or error code.
  - When the sendlnbroadcast macro command is used, the carriage return is sent one more time after last parameter.
  - added the sendlnmulticast command.
- Bug fixes
  - The response of DECLRMM status query by DECRQM was invalid.
  - PrnConvFF can not be loaded from TERATERM.INI file.
  - sendbroadcast and sendlnbroadcast macro command does not work.
  - sendbroadcast, sendlnbroadcast and sendmulticast macro command can't send the character of 0x00 or 0x01.
- Misc
  - upgraded TTSSH to 2.82.
  - upgraded Oniguruma to 6.6.0.

### 2017.05.31 (Ver 4.95)

- Changes
  - added new feature regarding How to scroll the screen when the window size is maximized.
    - changed default action to the new method. If the action behaves in the same manner as Tera Term 4.94, please set MaximizedBugTweak to 1.
    - changed MaximizedBugTweak value from on/off to 0/1/2 combination. The "off" is treated as 0, and the "on" is treated as 2.
  - added the notification feature regarding clipboard accessing from the remote host. (Windows Me or 2000 or later)
  - changed default directory path for receiving a file (Vista or later:Downloads, XP or earlier:My Documents).
  - renamed command line from /NAMEDPIPE to /PIPE option.
  - When /PIPE option is used as command line, the host name is complemented by these rules:
    - If the host name begins with a '\', the name is not changed.
    - If the host name does not include a '\', the '\\.\pipe\' is added at the beginning.
    - If the host name includes a '\' anywhere but first, before that is treated as server name and after that is treated as pipe name.
- Bug fixes
  - The port number cannot specify 65535 by the command line option.
  - When the New connection selects Serial menu, a part of TCP/IP menu is not disabled.
- Misc
  - upgraded TTSSH to 2.81.
  - upgraded Oniguruma to 6.2.0.
  - upgraded the version of Inno Setup that is used for the installer. Because a vulnerability of Inno Setup has been fixed. (Announce from TeraTerm Project, Inno Setup Revision History, JVN#06770361, CVE-2017-2193)
  - NOTICE: The installer no longer support Windows 95, 98, Me and NT 4.0. Please use the zip archive version on these Windows.

### 2017.02.28 (Ver 4.94)

- Changes
  - added `&u' parameter to log file name that can convert the logon user name.
  - added new line normalization on pasting. The default is off.
    - This feature can be enabled on Copy and Paste tab of Additional settings dialog.
  - added the setflowctrl command.
- Bug fixes
  - When Restore setup is called, the AlphaBlend can not be restored immediately.
  - When Paste<CR> works, the end of data will be added invalid character.
  - When Kanji(receive) is set to UTF-8, garbled characters will be shown after invalid byte characters are received.
- Misc
  - upgraded TTSSH to 2.80
  - upgraded TTXttyrec Plug-in to 1.03
  - upgraded Oniguruma to 6.1.3.
  - upgraded SFMT to 1.5.
  - changed starting method of LogMeTT and TTLEditor installer.

### 2016.11.30 (Ver 4.93)

- Changes
  - added 48dot icon in the keycode.exe.
- Bug fixes
  - After Kanji(receive) is set to EUC and UTF-8 string is shown, new Kanji(Chinese character) may be properly shown when Kanji(receive) is set to UTF-8.
  - When Kanji(receive) is set to UTF-8, ISO-2022-JP Kanji can not be properly shown with Japanese language setting.
  - When DeferredLogWriteMode=on is enabled and a log file is closed soon after opening the file, Tera Term rarely halts by dead-lock.
  - When Log dialog is closed, the memory leak of Tera Term core(ttermpro.exe) is happened.
  - Windows 7 and Vista: When special operation is done on General setup dialog, an application fault occurs.
  - When the real time mode is off by using broadcast command, invalid character will be added at the end of string.
  - MACRO: When closesbox command is executed, the memory leak of Macro core(ttpmacro.exe) is happened.
  - MACRO: The gethostname, gettitle, getmodemstatus, loginfo and logopen command will rarely be wrong.
- Misc
  - upgraded TTSSH to 2.79
  - upgraded CygTerm+ to 1.07_29
  - upgraded TTProxy to 1.0.0.24
  - upgraded TeraTerm Menu to 1.14
  - upgraded TTX KanjiMenu Plug-in to 0.1.7
  - upgraded TTXRecurringCommand Plug-in to 1.05
  - upgraded Oniguruma to 6.1.2.

### 2016.08.31 (Ver 4.92)

- Changes
  - added new feature which removes carriage return from end of line with pasting. The default value is off.
    - The function can be enabled at Copy and Paste tab of Additional settings dialog.
  - When scroll back is used, scroll state is always reset with user input.
  - ZMODEM: The default escaped character are added LF and GS by sending.
  - The default value of MaxComPort setting is increased from 4 to 256.
  - changed macro command line behavior.
    - Strictly checked the syntax of command line option. When an unnecessary option is added at option back like as /Vxx, the option is not recognized.
    - The option placement can be only specified before a filename. When the option is specified after the filename, the option is recognized as macro parameter.
  - MACRO: The `params' string-typed array that is stored command line parameter(s).
- Bug fixes
  - When the clipboard is read from remote host, unnecessary NUL character is added at the end of the string.
  - When the clipboard is written from remote host, empty string can not be set.
  - When the clipboard is empty string and Bracketed Paste Mode is enabled, final Bracket is only sent by pasting.
  - ZMODEM: The escaped 0x7f and 0xff that is included in ZMODEM header packet can not be restored.
  - Tera Term(ttermpro.exe) can not run on Windows 95/98/Me/NT4.0.
  - MACRO: When invalid regular expression is specified at the strreplace command, source string is corrupted.
    - The result variable returns -1 when invalid regular expression is specified.
- Misc
  - upgraded TTSSH to 2.78
  - upgraded TTProxy to 1.0.0.23

### 2016.05.31 (Ver 4.91)

- Changes
  - Tera Term waits for port connection when the serial port does not exist.
    - added the /WAITCOM command line option.
    - added the WaitCom entry in the teraterm.ini file. The default value is off.
  - added the LF entry in the New-line(transmit).
  - When ZmodemAuto=on is enabled and ZRINIT packet is received, the file selection dialog of ZMODEM sending is opened.
  - updated to new Tera Term icon file(teraterm.ico, vt.ico) and macro icon file(ttmacro.ico). Special thanks to Tatsu Sakamoto.
- Bug fixes
  - The background color erase(BCE) does not work with DECFI, DECBI control sequence.
  - When AutoComPortReconnect=on is enabled, Tera Term can not recognize a part of device regarding USB serial port connection and disconnection.
  - When Log Rotate is enabled and an existing file is logged, first file can not be rotated by specified size.
  - MACRO: When if has macro command without parameter, syntax error occurs.
- Misc
  - upgraded TTSSH to 2.77

### 2016.03.05 (Ver 4.90)

- Changes
  - Changed XMODEM options
    - Error detection type(Checksum/CRC) can be specified at sending receiving.
    - Packet size(1K) can be specified at receiving sending.
    - The xmodemrecv and xmodemsend macro argument is the same.
  - Cancel from remote host at XMODEM transmitter becomes as transfer failure.
  - When remote host sends 1K packet against Checksum at XMODEM receiving, Tera Term receives data as Checksum/1K.
  - When remote host sends NAK at XMODEM CRC sending, Tera Term sends data as Checksum.
  - added configuration for XMODEM, YMODEM and ZMODEM timeout value.
    - added the XmodemTimeouts entry in the teraterm.ini file.
    - added the YmodemTimeouts entry in the teraterm.ini file.
    - added the ZmodemTimeouts entry in the teraterm.ini file.
  - XMODEM: Send and Receive dialog's option can not be affected each other.
  - MACRO: When if does not have statement, macro error always occurs.
- Bug fixes
  - BCE information does not be updated at OSC 4/11/104/111 control string.
  - XMODEM: When CRC sends, Checksum may send half way incorrectly.
  - Eterm look-feel: When invalid image file is specified as background, an application fault occurs.
  - The return value of random macro command is the deviation of the pseudo random number.
    - The specified maximum value will be a very low probability.
    - When the maximum value is specified as over 32768 number, any value can not be generated.
    - Random generation is used for SFMT.
  - When invalid folder type is specified on the getspecialfolder macro command, the desktop folder is returned by mistake.
  - MACRO: When getipv6addr command is called on Windows 2000, an application _ttpmacro.exe_ fault occurs.
- Misc
  - upgraded TTSSH to 2.76
  - upgraded CygTerm+ to 1.07_28

### 2015.12.01 (Ver 4.89)

- Changes
  - The parameter check of the control sequence can be reinforced.
  - added support for querying the status of DECSLRM and DECSCUSR by using the DECRQSS control sequence.
  - When the baud rate is high speed on the serial connection, the file transfer can be accelerated.
    - added the FileSendHighSpeedMode entry in the teraterm.ini file. The default value is on.
  - Eterm look-feel: added the Image Brightness configuration.
  - added the Virtual Store path to Setup directory.
  - The cygterm.cfg is not saved on dialog closing but is saved on the Save setup when the CygTerm configuration of the Additional settings is used.
  - The command line option can be quoted from an offset when the '"' is used.
  - When the click-able URL is not double-clicked but single-clicked on the version dialog, the browser can be launched.
  - MACRO: added new parameter which can specify an index of selected item at the listbox macro command.
- Bug fixes
  - When the host name includes a comment on new connection dialog, it will not connect to the remote host.
  - When the USB serial cable is inserted and extracted while the serial connection is doing, new serial connection will be failed. However, this fix is supported on the Windows XP or later.
    - added the AutoComPortReconnect entry in the teraterm.ini file. The default value is on.
  - The cygterm.cfg file can not be saved in the Virtual Store environment.
  - The status line can not work well.
- Misc
  - upgraded TTSSH to 2.75
  - upgraded TTProxy to 1.0.0.22
  - upgraded TTXRecurringCommand Plug-in to 1.04
  - upgraded LogMeTT to 2.12

### 2015.09.01 (Ver 4.88)

- Changes
  - When the color palette is changed and inquired with the OSC 4, the palette number(256, 258, 259) is treated as the highlight, blinking and reverse attribute color.
  - When the color is inquired with the OSC 4, OSC 10 and so on, the terminal character is matched to the requested character.
  - The all attribute color is reset to the initial status with the OSC 105 ST.
  - added the button to open a configuration file to Setup directory.
  - MACRO: A dialog of the filenamebox and dirnamebox is on top of all the other windows.
- Bug fixes
  - When the port number is not 23 on local connection, the Cygwin connection starts by Alt+D(Duplicate session) key.
  - When the Meta key is set to left or right, the combination key with the Alt and the cursor/Insert/etc edit keypad can not work well in the KEYBOARD.CNF.
- Misc
  - upgraded TTSSH to 2.74
  - added support for Microsoft Windows 10.

### 2015.05.31 (Ver 4.87)

- Changes
  - added the [Setup directory] under the [Setup] menu.
  - MACRO: A macro file described in UTF-8 BOM can not report a syntax error.
  - MACRO: A numerical value can be specified at the filewrite, filewriteln macro command.
- Bug fixes
  - The keyboard(CNF) configuration will be reset when a new connection is created.
- Misc
  - upgraded TTSSH to 2.73
  - upgraded TTProxy to 1.0.0.21
  - upgraded TeraTerm Menu to 1.13
  - upgraded LogMeTT to 2.10.3
  - changed the domain name from SourceForge.jp to OSDN.

### 2015.02.28 (Ver 4.86)

- Changes
  - When the [Reset Terminal] on the [Control] is called, the color setup with OSC 10/11 will be reset.
  - YMODEM: The block0 packet size meaning end of transfer is 128 byte at all time. Special thanks to mlukoshkov.
  - YMODEM: The packet of file information is not fixed size but variable size(128 or 1024byte).
  - added the dirnamebox command.
  - added the getmodemstatus command.
- Bug fixes
  - When the DECBI control sequence is used on the left of the screen, the wide character of the left screen will be incorrectly removed.
  - The KEYBOARD.CNF file can not be loaded when the Tera Term is performed with the macro script.
  - YMODEM: When the data is sent, the CANCEL command from the remote host does not work well.
  - YMODEM: When the received file information contains only a file name, an end of the file name is broken.
  - YMODEM: When the received file information does not include the file size, the file data can not be recorded well.
  - The setting value of the Log Rotate will not display well.
  - When the x=0,y=0 is specified by the setdlgpos macro command, the statusbox will be newly opened and however the statusbox can not be properly shown.
  - When the macro filename is so longer, the currently executing line number can not be shown. And also, the macro window can be re-sizable.
- Misc
  - upgraded TTSSH to 2.72
  - upgraded CygTerm+ to 1.07_25
  - upgraded Oniguruma to 5.9.6.

### 2014.11.30 (Ver 4.85)

- Changes
  - added support for the pause time while the break signal is sending to the serial port.
    - added the SendBreakTime entry in the teraterm.ini file.
  - The Alt+D and Alt+I accelerator key can only be worked on the VT window.
  - added new optional setting that can disable accelerator key of New Connection.
    - added AcceleratorNewConnection entry to teraterm.ini.
  - added new optional setting that can disable accelerator key of Cygwin connection.
    - added AcceleratorCygwinConnection entry to teraterm.ini.
  - added the 3rd argument to specify the initial directory at the filenamebox macro command.
  - added the 4th argument to open a text file for reading at the fileopen macro command.
- Bug fixes
  - The language file will not be shown in the General setup.
  - When the connect macro command is failed, the command will be failed again.
  - The floating point number can not be specified in the sprintf, sprintf2 macro command.
  - The character width and precision specifying of the format style can not use the * character in the sprintf, sprintf2 macro command.
- Misc
  - upgraded TTSSH to 2.71
  - added the Traditional Chinese.lng language file. Special thanks to Wei Yan.
  - added support for 64bit Cygwin connection automatically.
  - removed the 64bit cyglaunch.exe program.

### 2014.08.31 (Ver 4.84)

- Changes
  - When a file is received by using YMODEM or ZMODEM protocol, the file time-stamp is updated.
  - added the log type configuration on the Log tab of the Additional settings dialog.
- Bug fixes
  - When the LanguageUI is changed on the General setup dialog, the help file can not be switched.
  - MACRO: The last line number can not display on the macro execution dialog.
- Misc
  - added support for Microsoft Windows Server 2012 R2.
  - upgraded TTSSH to 2.70
  - upgraded TeraTerm Menu to 1.12
  - upgraded TTXResizeMenu Plug-in to 1.03
  - upgraded LogMeTT to 2.10.2
  - added the 64bit cygterm.exe and cyglaunch.exe into the installation directory.

### 2014.06.01 (Ver 4.83)

- Changes
  - The cursor position can be moved to the top-left of the screen when the screen is clear.
    - added support for the TTCTH control sequence.
  - added support for Termcap/Terminfo string query.
    - Refer to the Background color for the vim user.
  - Eterm look-feel: Changed the background image from label to check-box style on the Visual tab of the Additional settings dialog.
  - added support for selecting any type of the Debug mode.
    - added the DebugModes entry in the teraterm.ini file.
- Bug fixes
  - The background color will not be painted well after the cursor position is restored.
  - Eterm look-feel: The background image file will not be drawn by using any JPEG file.
  - Fixed some bugs regarding Debug mode
    - When the debug mode is entered, the insertion mode and the auto-wrap mode may be changed.
    - When the debug mode is entered, the character attribute can not be reset.
    - When the debug mode is leaved, the character attribute may be reset.
- Misc
  - upgraded TTSSH to 2.69
  - upgraded TTProxy to 1.0.0.20
  - upgraded LogMeTT to 2.10.1.7

### 2014.03.08 (Ver 4.82)

- Changes
  - A multicast name by using the sendmulticast macro command can be specified with the /MN command line option.
- Bug fixes
  - A cursor can not be moved to right edge by using the CHA, HPA control sequence.
  - MACRO: By using the `include' macro command, an application fault occurs while running ttpmacro.exe.

### 2014.02.28 (Ver 4.81) Celebrating 20 years

- Changes
  - Macro
    - added the uptime command.
    - The value by using logautoclosemode is set to default when the macro script is terminated.
- Bug fixes
  - When the window size is changed, the cursor moves to the left margin.
  - The "Include screen buffer" option appears in the "Send file" and "ZMODEM Send" dialog.
  - When the LanguageUI is changed on the General setup dialog, the window title can not be updated.
  - MACRO: A macro file larger than 1MB slows down the performance.
- Misc
  - upgraded TTSSH to 2.68
  - upgraded TTProxy to 1.0.0.19
  - upgraded LogMeTT to 2.10.1
  - upgraded TTLEditor to 1.5

### 2013.11.30 (Ver 4.80)

- Changes
  - can be changed the maximum size of the OSC string
    - added the MaxOSCBufferSize entry in the teraterm.ini file. The default value is 4096.
  - added the "Include screen buffer" option in the Log dialog box.
    - added the LogIncludeScreenBuffer entry in the teraterm.ini file.
    - added the "Include screen buffer" option at the "logopen" macro command.
  - added the /ES command line option. It enables the "New connection" dialog.
  - When the URL string is divided at the end of the line, new setting can enable to concatenate the whole string.
    - added the JoinSplitURL and JoinSplitURLIgnoreEOLChar entries in the teraterm.ini file.
  - Macro
    - added the TTL filename on the error and execution dialog.
    - Saves and restores the timezone when the gettime and getdate command executes.
- Bug fixes
  - When the terminal size is changed, the left and right margin mode (DECLRMM) does not cleared.
  - The VPR/VPB/HPR/HPB control sequences are affected by the scroll margin.
  - A cursor will be moved to upper screen over by using the CUU/VPB control sequences.
  - The VPB control sequence will be released with a part of mode.
  - The DECFI/DECBI control sequence ignores the scroll margin.
  - The DECBI control sequence mistakes for saving the cursor position.
  - The DECFI control sequence mistakes for changing the application keypad mode.
  - When the log file is opened, the "Hide dialog" function does not work well.
  - When the tool chip is minus position on resizing, the tool chip is shown on the primary monitor with the multi monitor environment.
  - Tera Term(ttermpro.exe) can not run on Windows 95/NT4.0.
- Misc
  - upgraded TTSSH to 2.67
  - upgraded TTXRecurringCommand Plug-in to 1.03
  - added support for Microsoft Windows 8.1.
  - upgraded Oniguruma to 5.9.5.
  - added the Simplified Chinese.lng language file. Special thanks to LiShaohui.

### 2013.09.01 (Ver 4.79)

- Changes
  - added support for the DECRQM(Request Mode) control sequence.
  - added support for left and right margin.
    - added support for DECLRMM(Left Right Margin Mode), DECSLRM(Set Left and Right Margins) control sequences.
  - When the Exit All is called, the user is always confirmed.
  - added the Undo menu under the Window menu when Tera Term's windows are arranged.
  - The file transferring dialog can not be shown.
    - added the FTHideDialog entry in the teraterm.ini file. The default value is off. Special thanks to Teodor Robas.
  - The beep sound can be suppressed when the bell ringing is rushed.
    - added the BellOverUsedTime, BellOverUsedCount and BellSuppressTime entries in the teraterm.ini file. The default value are 2 , 5 and 5.
  - added the /AUTOWINCLOSE command line option to control the Auto window close.
  - Macro
    - added the "Unknown command." new message in the Error messages.
    - added the logautoclosemode command.
    - added the detail information(line number and error token) on the error dialog.
- Bug fixes
  - When the UseNomalBGColor is on, the OSC 111(Resetting standard background color) control string after the OSC 11(Setting standard background color) can not reset the background color of characters including bold attribute and so on.
  - The sequence reporting the cursor change can not recognize the upper margin when the origin mode is enabled.
  - Both the Intermediate Byte and Private Parameter control sequence can not be ignored.
  - When the SelectOnActivate is off, the button released event is incorrectly sent by clicking the in-active window.
  - When second Tera Term is launched, the keyboard configuration file can not be read.
  - When the file is sent by D&D, the help button of the dialog can not be worked well.
  - MACRO exec: The show parameter will be ignored when the wait parameter is 1(4.63 later) or the parameter is not 1(4.78 later).
- Misc
  - upgraded TTSSH to 2.66
  - upgraded CygTerm+ to 1.07_24

### 2013.05.31 (Ver 4.78)

- Changes
  - Select "Selection" by default in the printer dialog when there is a selection. Special thanks to tentner.
  - added the Log Rotate configuration on the Additional settings dialog.
    - added the LogRotate, LogRotateSize, LogRotateSizeType and LogRotateStep entries in the teraterm.ini file.
  - added the Exit All under the File menu.
  - added the Cascade, Stacked and Side By Side under the Window menu.
  - added the /nolog command line option to disable the Auto start logging.
  - Macro
    - added the listbox command.
    - added the getipv4addr command.
    - added the getipv6addr command.
    - added the logrotate command.
    - added the crc16, crc16file command.
    - added the checksum8, checksum8file command.
    - added the checksum16, checksum16file command.
    - added the checksum32, checksum32file command.
    - added the bringupbox command.
    - added the regexoption command.
    - added the 4th argument(current directory) at the exec command.
    - The 'show 1' command brings the macro window to the top.
    - The messagebox, inputbox and listbox commands bring the macro dialog to the top.
    - The wait, waitln and waitregex commands can wait an empty strings.
    - When the waitregex command matches some parameters at the same time, the first matched parameter is selected.
- Bug fixes
  - Can not create a file including the IPv6 address in the &h of the log file.
  - When the LogLockExclusive is off, the exclusive lock remains in the log file..
  - When a log file is retrieving on the network path, Tera Term does not go slow.
    - added the DeferredLogWriteMode entry in the teraterm.ini file. The default value is ON.
  - When the URL string ends at the right row and return code, the URL string continues to next line by mistake.
  - The URL string on the mouse hand cursor shifts to the left with half character by mistake.
  - MACRO: The send/sendln command can be affected by the Paste delay per line configuration.
  - MACRO: When the timeout is 0, the waitn command can not wait any character.
  - MACRO: When the break command is executed after the continue command, the Invalid Control error will be occurred.
  - MACRO: The box-style macro command can not show the dialog position well on the multi display.
  - MACRO: The wait and waitln command can not detect the right string.(ex. wait "aab" does not work against "aaab")
- Misc
  - added the Russian.lng language file. Special thanks to Sergey Ryumik.
  - added the Korean.lng language file. Special thanks to Daehong Kim.
  - upgraded TTSSH to 2.65
  - upgraded Oniguruma to 5.9.4
  - added support for Microsoft Windows Server 2012.

### 2013.02.28 (Ver 4.77)

- Changes
  - added support for the DECFRA (Fill Rectangular Area) control sequence.
  - added support for the window-ops control sequence to push/pop window title on stack.
  - Macro
    - added the continue command.
    - Changed the maximum length of the string variable to 511 bytes.
- Misc
  - upgraded TTSSH to 2.64
  - upgraded TTXResizeMenu Plug-in to 1.02
  - upgraded TTXKCodeChange Plug-in to 1.01

### 2012.12.02 (Ver 4.76)

- Changes
  - added support for the SGR 38:2, 48:2(the character and background color changing specified by RGB value). The nearest color with 256 color palette is used.
  - added support the colon(:) separator with the SGR 38:5, 48:5(the character and background color changing specified by RGB value). Refer to the ISO/IEC 8613-6 (ITU-T Rec. T.416).
  - The method of the special folder is changed from reading the registry to SH API.
  - Do not save the VTIcon and TEKIcon entries into the teraterm.ini file.
  - When a ini file can not be written at the Save setup, the error message will be shown.
- Bug fixes
  - The palette out of range number can not be ignored with the SGR 38:5, 48:5(the character and background color changing specified by RGB value).
  - A string pasted by clipboard will be corrupted with any keyboard layout.
  - The strreplace macro command will be crashed when the 'matchstr', 'groupmatchstr1' - 'groupmatchstr9' system variables are specified as the argument.
- Misc
  - upgraded TTSSH to 2.63
  - added support for Microsoft Windows 8.
  - upgraded Oniguruma to 5.9.3

### 2012.08.31 (Ver 4.75)

- Changes
  - A button value is changed from 3 to 35 while the button is not pressed at the Any Event Tracking mode.
  - added the 0; character at the reply head by requesting the character attribute of the DECRQSS.
  - At requesting the character attribute of the DECRQSS, the color attribute is not included in reply when the Enable ANSI Color is off.
  - When the host number is discontinuous value, Tera Term can read the [Hosts] section in the teraterm.ini file.
  - Macro
    - added the setpassword command.
    - added the ispassword command.
- Bug fixes
  - Named pipe: The pipe can not be disconnected when the Oracle Virtual Box is terminated.
  - COM port: The default setting can not be saved in the teraterm.ini file.
  - YMODEM: When the receiving a file is temporarily stopped, Tera Term can not send a NAK after timeout. So, the transferring can not be continued.
  - Macro command: The send and sendln can not transmit a character #01.
  - Macro command regarding file using: A relative path will not be recognized.
    - The base of a relative path will be a path existing a macro file or Tera Term installation directory. By using this bug fix, the relative path can be a path existing a macro file.
- Misc
  - upgraded TTSSH to 2.62

### 2012.05.31 (Ver 4.74)

- Changes
  - Serial port connection
    - added the mark parity, space parity and 1.5 stop bit on the serial port setup.
    - added the "mark" and "space" name of the Parity entry. The default is "none".
    - added the "1.5" name of the StopBit entry. The default is "1".
  - Named pipe
    - added support for the named pipe. Tera Term can connect the serial port of the VMware and Hyper-V.
    - A named pipe can be specified into the TCP/IP:Host entry of New connection dialog.
    - added the /PIPE option by specifying the named pipe.
  - added the AUTO entry in the New-line(receive). Special thanks to tentner.
  - added the selection of the font quality.
    - added the Font quality configuration on the Additional settings dialog.
  - added the SCP destination path on the confirmation dialog when a user drags a file to TeraTerm window.
    - added the ScpSendDir entry in the teraterm.ini file.
  - Eterm look-feel
    - Environment variable strings(%variableName%) can be included in the ini file path.
    - added an image file specified configuration(theme\ImageFile.INI). Also, a background image file can be specified on the Additional settings dialog.
    - Enabled the "Eterm lookfeel" check-box on the Additional settings dialog.
  - added the LanguageUI entry on the General setup dialog.
  - A message dialog is shown when the cygterm.cfg has been saved on the Cygwin tab of the Additional settings dialog.
  - added support for IME feedback back and forth function. The ATOK2012, MS-IME2002 and MS-IME2003 work well. Also, this feature is disabled with "IME=off"(teraterm.ini).
  - Removed an extra semicolon(;) included in the window size requesting.
  - Macro
    - added the "paramcnt"(argument count) and "param1"(macro filename) in the Variables.
    - added a sample code in the connect command.
    - added the filelock command.
    - added the fileunlock command.
    - added the third argument _timezone_ at the gettime and getdate command.
- Bug fixes
  - KERMIT protocol
    - The initial parameters of the KERMIT server do not be checked well.
  - The drop down list's items are not shown on Windows 2000 or earlier.
  - Fixed a typo of the Cyrillic letter translation table(range of CP866 and ISO8859-5).
  - A string array can not be recognized as the argument of the macro command.
- Misc
  - upgraded TTSSH to 2.61

### 2012.02.29 (Ver 4.73)

- Changes
  - added support for following control strings.
    - OSC 5 (Change bold/blink/reverse attribute color)
    - OSC 104 (Reset color palette)
    - OSC 105 (Reset bold/blink/reverse attribute color)
    - OSC 110 (Reset VT window text foreground color)
    - OSC 111 (Reset VT window text foreground color)
    - OSC 115 (Reset TEK window text foreground color)
    - OSC 116 (Reset TEK window text foreground color)
  - added support for reading the Clipboard by using the OSC 52(clipboard accessing) control sequence.
  - added support for xterm(UTF-8), xterm(SGR) and rxvt-unicode style extended mouse tracking mode.
  - When the receiving file is empty, the file name is assigned to no-name.
  - When the receiving file name contains banned characters, these characters are replaced to _.
  - KERMIT protocol
    - Changed the MAXL from 90 to 94. Workaround for failing to communicate against NT-4S(Hitachi VoIP gateway).
    - Improved the KERMIT.LOG more easily.
    - added the KmtLongPacket entry in the teraterm.ini file. The default value is off.
    - added the KmtFileAttr entry in the teraterm.ini file. The default value is off.
  - added support for exclusive-locking the log file in written mode.
    - added the LogLockExclusive entry in the teraterm.ini file. The default value is on.
  - added the "loginfo" macro command.
- Bug fixes
  - Updated the Cyrillic letter translation table(range of KOI8-R, CP866, Windows-1251 and ISO8859-5).
  - The packet number will not be correct while sending a file by using the XMODEM and YMODEM protocol.
  - When a log is started, the log window is temporarily activated. However, this is enabled for Windows 2000 later.
  - "filerename" macro command: When a file can not be renamed, the error code stores to the result variable.
  - "filedelete" macro command: When a file can not be removed, the error code stores to the result variable.
- Misc
  - upgraded TTSSH to 2.60

### 2011.12.04 (Ver 4.72)

- Changes
  - added support for OSC 10 (Change VT window text foreground color), 11 (Change VT window text background color), 15 (Change TEK window text foreground color) and 16 (Change TEK window text background color) control string.
  - added support for OSC 52 (Clipboard access) control string.
    - added the Clipboard access from remote entry on the Additional settings dialog.
  - added support for configuring the control sequence to change permitted tab-stops.
    - added the TabStopModifySequence entry in the teraterm.ini file. The default is on.
  - Broadcast Command: When a user uses the real time mode, the input characters does not show on the edit control.
  - added support for specifying an any browser as the click-able URL.
    - added the ClickableUrlBrowser and ClickableUrlBrowserArg entries in the teraterm.ini file. The default value is empty.
  - added the [Minimize All] and the [Restore All] menu into the [Window] menu.
  - added support for the xterm back tab key.
    - added the XBackTab entry in the [X function keys] section of the keyboard configuration file.
  - added support for the Integer Array, String Array.
  - added the "getspecialfolder" macro command.
  - adjusted the up and down space size of the shown message at the "messagebox", "inputbox" and "statusbox" macro commands.
- Bug fixes
  - The string following after OSC string will not display well.
  - When the cursor is hid, the vertical bar shape can not be shown.
  - When the keyboard has the AltGr key and the MetaKey=on is configured, the invalid character will be input.
  - The zero index of the ANSI color settings can not be loaded.
  - XMODEM: The first packet is sent out twice by using the xmodem sending function.
  - YMODEM: The received file can not be saved.
  - "ifdefined" macro command: When the integer literal is specified, the command mistakenly returns the integer type.
- Misc
  - Modified Tera Term installer script
    - Cygterm Here can be launched by the right-click to a opened folder on Windows Vista and 7 later.
  - upgraded TTSSH to 2.59
  - upgraded TeraTerm Menu to 1.11
  - upgraded TTXRecurringCommand Plug-in to 1.02
  - upgraded TTLEditor to 1.4

### 2011.8.31 (Ver 4.71)

- Changes
  - When the OSC string includes a control sequence, the control sequence can be proceeded.
  - Eterm look-feel: The wallpaper file format can support any format other than BMP on Windows Vista or later.
  - "getpassword" macro command is updated.
    - The result of the command execution is stored in the system variable "result".
  - "strspecial" macro command is updated.
    - added the second argument as the converted string on the strspecial command.
  - added the "expandenv" macro command.
- Bug fixes
  - The log file which name length is 80 bytes over can not be opened.
  - When the meta key is enabled, the Control and Meta key is redundantly input.
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.58

### 2011.6.26 (Ver 4.70)

- Changes
  - DEC special character font can support the bold and the under line attribute.
  - added support for the NetTerm style mouse event tracking.
  - added support for ignore the printing control sequence.
    - added the PrinterCtrlSequence entry in the teraterm.ini file. The default value is off on.
  - The Meta Key can be only assigned to the left ALT or the right ALT key.
  - By using the broadcast command in the real time mode, the Submit button has the only function of acting as <Enter> key.
  - The /k option is inherited by using the Duplicate Session.
  - added the elapsed time and the transfer speed on the file sending dialog.
  - added support for Windows7 jump list.
  - Resurrected the special argument of the box-style macro command. However, this option is obsolete. The default is 0 because of backward compatibility.
- Bug fixes
  - When the mouse cursor position is later 224 line on xterm-style mouse event notification, Tera Term would report the invalid reporting.
  - When the 10000 over mode is specified on the DECSET/DECRST control sequence, Tera Term would not be able to ignore.
  - The invalid result may be responded for the window position reporting.
  - YMODEM: When a file is sent, the block1 can be sent not waiting the ACK from the YMODEM server.
  - When a last one byte of a string is removed by using the strremove macro command, the BOF will be occurred.
- Misc
  - Modified Tera Term installer script
    - Bug fix: When the CygTerm Here is added in the context menu, the CygTerm Here does not work well with the folder name containing continuing spaces.
  - upgraded TTSSH version supporting SSH2 to 2.57
  - upgraded TeraTerm Menu to 1.10
  - upgraded CygTerm+ to 1.07_23
  - upgraded cyglaunch to 1.03
  - upgraded LogMeTT to 2.9.9

### 2011.3.5 (Ver 4.69)

- Changes
  - added support for configuring the Terminal ID included in the DA3 control sequence reply.
    - added the TerminalUID entry in the teraterm.ini file. The default value is FFFFFFFF.
  - added support for the DECSTUI (Change Terminal Unique ID) control sequence.
    - added the LockTUID entry in the teraterm.ini file. The default value is on.
  - added support for the DECRQSS (Request terminal setting) control sequence. Supported control sequences are DECSCA, DECSCL, DECSTBM and SGR.
  - added support for the DECFI, DECBI control sequences.
  - The control sequence requesting window size can reply the actual window size instead of the fixed 480x640 value.
  - When the ConfirmChangePaste is enabled, a user is confirmed with pasting the text by using Alt+R accelerator key. The ConfirmChangePaste can confirm when only one line is pasted.
  - added support for mintty's application escape mode.
  - added support for mintty's mouse wheel reporting control control sequence.
  - added support for the IME operation control sequence.
  - added the "basename" and "dirname" macro command.
  - added the "getfileattr" and "setfileattr" macro command.
  - added the "foldercreate", "folderdelete" and "foldersearch" macro command.
- Bug fixes
  - When the terminal width is 257 columns over, Tera Term does not display well.
  - When the terminal ID is VT520 and VT525, the Primary DA (DA1) reply is incorrect.
  - When the language is other than Japanese, the VT420, VT520 and VT525 on the Terminal Setup dialog do not work well.
  - When PassThruPort is specified as a local device mapping the network share, Tera Term printing does not work. cf.print with WINDOWS 7 net use LPT PERSISTENT:Yes
  - Tera Term can not ignore the unsupported OSC control string.
  - Tera Term can not understand a character after the DCS, SOS, APC and PM Control string.
  - When a log file is opened by writable mode, the file is existing and writing by another process can be opened.
  - When 8-bit string is received, the string is recognized as the control sequence by mistake.
  - Tera Term can not properly send a broadcast message to selected windows by using the broadcast command. cf.Broadcast command issue in 4.68
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.56
  - upgraded TTProxy to 1.0.0.18
  - upgraded CygTerm+ to 1.07_22
  - upgraded LogMeTT to 2.9.8
  - Add Delete mutex object for running check by installer.

### 2010.12.7 (Ver 4.68)

- Changes
  - added support for the selective erase.
    - added support for the DECSCA (Select character protection attribute), DECSED (Selective Erase in Display), DECSEL (Selective Erase in Line) and DECSERA (Selective Erase Rectangular Area) control sequence.
  - added support for the DECERA (Erase Rectangular Area) control sequence.
  - added support for the DA3 (Tertiary Device Attribute) control sequence.
  - added support for the VT420, VT520 and VT525 on the terminal ID settings.
    - The DECSCL(terminal mode setting) control sequence can support the VT level 5(vt500 series).
  - A single character to indicate the window status can be shown on the "Window" menu and "Windows list" dialog. See below.
    - + Normal window
    - - Minimized window
    - @ Maximized window
    - # Hidden window
  - Extended the maximum number of Tera Term window from 50 to 256.
  - Extended the maximum number of Tera Term plug-ins from 16 to 32.
  - added an argument of the "beep" macro command.
  - Deleted the special argument of the box-style macro command.
  - The WSAAsyncGetAddrInfo function can be hooked by using plug-in.
  - The freeaddrinfo function can be hooked by using plug-in.
- Bug fixes
  - Security fix: A class of vulnerabilities affecting applications that load DLL's in an insecure manner.
  - The baud rate can not be properly selected on the [Setup]-[Serial port] dialog.
  - Beep setting does not work.
  - The scroll region can not be cleared by using the DECALN (DEC Screen Alignment Test) control sequence.
  - An empty string can not reply by using the window title and icon label reporting request.
  - The rectangle erasing, color changing and line drawing can not work well in the IO-8256 terminal.
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.55
  - upgraded TTProxy to 1.0.0.17
  - upgraded CygTerm+ to 1.07_19
  - upgraded cyglaunch to 1.02

### 2010.8.31 (Ver 4.67)

- Changes
  - added the NextShownWin and PrevShownWin of new shortcut keys in the KEYBOARD.CNF file that display a next or previous window not minimized.
  - removed the hidden window from the target windows which switches by the shortcut key NextWin/PrevWin.
  - added a new optional setting that can disable the menu for "New connection" and "Duplicate session".
    - added the DisableMenuNewConnection and DisableMenuDuplicateSession in the teraterm.ini file. The default is off.
  - added a user configuration for changing the cursor color depending on the IME open status.
    - A user can change the setup value on the Additional settings dialog.
    - added the IMERelatedCursor in the teraterm.ini file. The default is off.
  - added support for the motion event of xterm style mouse event tracking.
  - added support for the DEC Locator Mode style mouse event tracking.
  - The ttymouse can automatically setup the xterm2 to modify the response of the Secondary DA.
  - added the "filetruncate" macro command.
  - added the "dispstr" macro command.
  - added the "strinsert" macro command.
  - added the "strremove" macro command.
  - added the "strreplace" macro command.
  - added the "strtrim" macro command.
  - added the "strsplit" macro command.
  - added the "strjoin" macro command.
  - added the "strspecial" macro command.
- Bug fixes
  - The YMODEM sending and receiving procedure does not work for the HyperTerminal.
  - The file sending is slowing.
  - The retransmission EOT does not work well by using the XMODEM protocol.
  - In xterm style mouse event tracking mode, the Control and Alt(Meta) keys are reported been swapped.
  - The color setup and request control sequence does not work well.
  - A statusbox is closed by performing the OK button action.
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.54
  - upgraded TTLEditor to 1.2.1
  - added the French.lng language file. Special thanks to Francois MOCQ.

### 2010.5.31 (Ver 4.66)

- Changes
  - YMODEM support
    - added the "YMODEM" under the Transfer of File menu.
    - added the YmodemRcvCommand entry in the teraterm.ini file. The default is empty.
    - added the "ymodemrecv" and "ymodemsend" macro command.
  - added support for specifying any baud rate of the serial port connection.
    - A user can specify any baud rate at the [Setup]-[Serial port] menu.
    - A user can specify any baud rate at the /BAUD option.
    - A user can specify any baud rate at the "setbaud" macro command.
  - added support for the VPB and HPB control sequence.
  - added support for bracketed paste mode.
  - Split the TransBin flag into the Send File and the Log flags.
    - added the LogBinary entry in the teraterm.ini file. The default value is off.
  - Change the cursor color depending on the IME open status.
  - Unlock the clipboard while the ConfirmChangePaste dialog is opened.
  - added the [Control]-[Show Macro Window] menu to flash the running macro window.
  - added the "filestat" macro command.
- Bug fixes
  - Fixed a problem where TeraTerm consumes 100% CPU if a USB serial port is disconnected. Special thanks to Z. Vickery.
  - When a user assigns a function to the Alt key in the KEYBOARD.CNF file, the unnecessary string print.
  - Fixed a problem the setting of line feed may not be effective at numerical keypad ENTER.
  - Line at a time can not work well in English and Russian language. Special thanks to p3g4asus.
  - Switching to alternate screen buffer, saving and restoring cursor position do not work correctly.
  - By using the "Save Cursor" control sequence, the alternate screen buffer switching and the screen clear execute in the wrong.
  - If ClearOnResize setting is on, DECCOLM (Change Column Mode) control sequence does not clear screen.
  - VPR control sequence does not work correctly.
  - Improved the cancellation logic for XModem and YModem transfers'. Special thanks to Z. Vickery.
  - The crc32file macro command does not work correctly for handling the file opening error. And also, the command supports the read-only file.
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.53

### 2010.2.20 (Ver 4.65)

- Changes
  - expanded the maximum number of saved host to 500.
  - expanded the maximum number of serial connection to 4096.
  - added support for the tab character as the command line delimiter.
  - enabled the [Show Log dialog] of the [File] menu while the log window is shown.
  - added the confirmation parameter at the "disconnect" macro command.
  - added support for not clearing the terminal screen while resizing.
    - A user can change the setup value on the Additional settings dialog.
  - added support for overwritten confirmation at the "filenamebox" macro command.
  - added support for replying an empty string at the window title and the icon label reporting control sequence.
    - Changed to the accept, ignore and empty value in the TitleReportSequence entry in the teraterm.ini file.
    - changed the default value of "TitleReportSequence" to "empty".
  - added Control Sequence tab on the Additional settings dialog
    - moved "Accept mouse event tracking request", "Disable mouse event tracking when Control is pressed" and "Accept window title change request" from General tab.
    - added "Title report sequence", "Window control sequence", "Window report sequence" and "Cursor control sequence".
  - added support for alternate screen buffer.
    - added the AlternateScreenBuffer entry in the teraterm.ini file. The default value is on.
- Bug fixes
  - When the Auto Window Close is disabled, the ttermpro.exe can not notify the XTYP_DISCONNECT transaction to the ttpmacro.exe.
  - PasteDelayPerLine setting does not work correctly.
  - The macro string-type constants can not describe a tab character.
  - When the multiple files are sent or received by the Kermit, ZMODEM and QuickVAN protocol, the progress bar can not be reset after the second file.
  - The `/*' characters in the macro string-type constants are falsely recognized as a beginning of the C language-style comment.
  - Workaround: When the Eterm look-feel is enabled, the screen display can not work after the Reverse Video (DECSCNM) set/reset.
  - When the width of the window is shrunk, the invalid character remains at the end of each line.
- Misc
  - stopped to write the new entry to the user's teraterm.ini file by the installer.
  - stopped to write the language configuration selected by a user to the user's teraterm.ini file by the installer.
  - upgraded CygTerm+ to 1.07_19
  - upgraded TTXRecurringCommand Plug-in to 1.01
  - upgraded TTXResizeMenu Plug-in to 1.01
  - upgraded TTXttyrec Plug-in to 1.02
  - added support for Microsoft Windows 7.
  - updated the screencapture.ttl file.
  - upgraded Oniguruma to 5.9.2
  - upgraded OpenSSL to 0.9.8l

### 2009.11.10 (Ver 4.64)

- Changes
  - The click-able URL color is able to be painted.
  - added configuring the underline attribute to click-able URL string.
    - added the check box on Additional settings dialog dialog.
  - When the click-able URL is enabled, the mouser cursor is not able to transform.
  - sftp/tftp scheme can be linked in a click-able URL.
  - The list of open sessions in the Broadcast Command window can support the standard Windows feature of selecting the range of items. It is possible to select consecutive number of items by clicking on the first and then pressing Shift key and clicking on the last. And also, it is possible to select all items by CTRL+A pushing.
  - added support for resizing the list box in the Broadcast Command window.
  - The list box in the Broadcast Command periodically updates.
  - added the status bar at the bottom of the ConfirmChangePaste dialog.
  - When a user switches the Tera Term window by using CTRL+TAB key, a new window style is not changed.
  - added the "setdebug" macro command.
- Bug fixes
  - fixed the problem that the settings of local echo and line feed before connection may not be effective.
  - fixed the problem that the settings of TCPLocalEcho/TCPCRSend in previous connection are not reset in serial connection.
  - fixed the problem that the invisible log dialog has focus when Tera Term start logging without displaying log dialog.
  - strscan macro command does not work correctly.
  - fixed the problem that the c language style comment does not work well.
  - fixed the problem that the tcp port number may not display on the window title.
  - Bug fix: "Enable bold font" setting is not immediately reflected.
- Misc
  - Modified Tera Term installer script
    - when SSH protocol was linked by the installer, it is able to edit by "File Types" of "Folder Options" on Explorer.
  - upgraded TTSSH version supporting SSH2 to 2.52
  - upgraded TTProxy to 1.0.0.16
  - upgraded LogMeTT to 2.9.7
    - Tera Term can access the registry key(HKEY_CURRENT_USER\Software\LogMeTT\InstallPath) to find the path to LogMeTT.

### 2009.7.5 (Ver 4.63)

- Changes
  - added support for cursor control sequences.
    - added the CursorCtrlSequence entry in the teraterm.ini file. The default is off.
  - added support for the control sequences for window operation.
    - added the WindowCtrlSequence, WindowReportSequence and TitleReportSequence entry in the teraterm.ini file. The default is on.
  - added support of "Line at a time" mode.
    - added the EnableLineMode entry in the teraterm.ini file. The default value is on.
    - change the default mode from "Character at a time" to "Line at a time".
  - added configuring the delay time per a carriage return when a user pastes multiple lines. The default is 10 msec.
    - A user can change the setup value on the Additional settings dialog.
  - Changed the BroadcastCommand functional specification. When the BroadcastCommand is not the real-time mode, a user can send a message at the selected window in the list box.
  - added UTF-8 language
    - added the /LA command line option for language mode specification.
  - In UTF-8 transmission mode, when the input character is recognized as invalid character, Tera Term sends the Replacement Character(U+FFFD).
  - changed Korean language implementation
    - added support for Korean mode with /LA command line option, which specifies the language mode.
    - added support for the IME in-line conversion.
    - added the `UTF-8m' selection for the receiving character code.
    - added the KS5601 at the KanjiSend and KanjiReceive entry in the teraterm.ini file.
    - added the KS5601 in the /KR and /KT command line options.
  - The OS common dialog is shown in the font setup dialog box.
    - added the character set (aka "Script") drop-down combo box.
    - moved the Enable bold style to [Setup]-[Window].
    - moved the Russian Font char set to [Setup]-[Terminal] for Russian mode.
  - added the MSB set character by using the Alt key.
    - added the Meta8Bit entry in the teraterm.ini file. The default value is off.
  - added `&p' parameter to log file name that can convert the tcp port number.
  - added the millisecond at the log time-stamp line.
  - respond for Secondary DA request only when it has no parameter or parameter 0.
  - add experimental support for the motion event of mouse event notify.
  - added a new optional setting that can disable the menu for "Send Break". Special thanks to peterprvy.
    - added the DisableMenuSendBreak in the teraterm.ini file. The default is off.
  - added a new optional setting that can clear the screen when disconnected. Special thanks to peterprvy.
    - added ClearScreenOnCloseConnection in teraterm.ini file. The default is off.
  - added a new optional setting that can disable the accelerator key for the Duplicate session.
    - added the DisableAcceleratorDuplicateSession entry in the teraterm.ini file. The default is off.
  - The /F command line option overwrites the other option.
  - Changed the command line specification regarding the double quotation.
    - A user can specify the "" characters instead of the " character.
  - added support for specifying any strings as the ConfirmChangePaste function.
    - added the ConfirmChangePasteStringFile entry in the teraterm.ini file. A user can specify a text file path enumerating any strings.
  - added the Wait4allMacroCommand entry in the teraterm.ini file. The default is off. Turn on the value to enable the "wait4all" macro command.
  - added the new option of the "exec" macro command that the application exit code is stored in the result variable.
  - added the C language style comment(/* - */) for the macro script. Limited support.
  - added a Subversion(SVN) revision number on the version dialog.
- Bug fixes
  - The settitle macro does not work after accepting the changing request of the window title, when the AcceptTitleChangeRequest is overwrite.
  - Not reset scroll-back function doesn't work when scroll region (DECSTBM) was set. For example, minicom sets the scroll region.
  - The continuedline copy does not work well.
  - When a user connects to the server after duplicating the ssh and cygwin session, TCPLocalEcho/TCPCRSend is ignored.
  - When the click-able URL characters are over 1024 byte, the application fault would occur.
  - Fix the problem that unsupported URI scheme can be linked in a click-able URL.
  - changed UTF-8 implementation
    - A character could send not converting it to the UTF-8 encoding when the sending mode is UTF-8.
    - The second character is late for sending by the UTF-8 encoding.
    - When receiving is the UTF-8 mode, some characters can not display.
    - When receiving is the UTF-8 mode, ISO-2022(SS2 and SS3) control code does not work.
  - changed Korean language implementation
    - Hangeul can not be selected by using double-click.
    - The control sequence of one character deletion(DCH) can not work Hangeul.
    - The carriage return can not work when Hangeul positioned at the end-of-line.
  - When a user pastes multiple lines, the application fault occurs on Windows 95.
  - Bug fix: the locale object is leaked.
  - When the 8 bit answering configuration(S8C1T) is enabled, an invalid character sticks after the Secondary DA answering.
  - When an incorrect option is specified, the option error does not occur. For instance, the /BADOPTION is recognized as the /B option.
  - The "sendmulticast" and the "setmulticastname" macro commands can not receive the value when the first argument is not a string but a user variable.
- Misc
  - Modified Tera Term installer script
    - linked .tty file to the Tera Term(TTXttyplay) program.
  - upgraded TTSSH version supporting SSH2 to 2.51
  - upgraded CygTerm+ to 1.07_17
  - upgraded TeraTerm Menu to 1.09
  - upgraded TTX KanjiMenu Plug-in to 0.1.6
  - upgraded TTXAlwaysOnTop Plug-in to 1.01
  - upgraded TTXttyrec Plug-in to 1.01
  - added TTXRecurringCommand plug-in in the Additional Plug-ins.
  - upgraded LogMeTT to 2.9.5
  - added limited support for Microsoft Windows 7 RC(Build7100).

### 2009.3.22 (Ver 4.62)

- Changes
  - The mouse event tracking can be disabled while a user pushes the Control key.
    - added DisableMouseTrackingByCtrl in teraterm.ini file. The default is ON.
    - added the check box on Additional settings dialog.
  - When the application cursor mode is disabled, TranslateWheelToCursor is disabled.
  - The TranslateWheelToCursor can be disabled while a user pushes the Control key.
    - added DisableWheelToCursorByCtrl in teraterm.ini file. The default is ON.
  - Disabled the "Eterm lookfeel" check-box on the Additional settings dialog. If a user enables the feature, directly edit the teraterm.ini file.
  - The hidden fonts can be shown on the font selection dialog with Windows 7 beta(build7000).
  - added support for specifying the reversed color.
    - added VTReverseColor entry in teraterm.ini file.
      Notice: This function is disabled for the backward compatibility when a user selects the upgrade installation. If a user want to enable this feature, turn on the EnableReverseAttrColor entry.
  - added being able to disable the high brightness color, the blink color, the reverse attribute color and the ANSI color displaying.
    - added EnableBoldAttrColor, EnableBlinkAttrColor, EnableReverseAttrColor, EnableURLColor and EnableANSIColor entries in teraterm.ini file. The default value of EnableReverseAttrColor is off, the others are on.
    - added the check box on Additional settings dialog.
  - Changed ConfirmChangePaste's default value into on.
  - Added EDITOR.CNF file in Tera Term installation package.
  - Changed the function of the editor keypad and the function key. When the keyboard configuration file is not found, TeraTerm sends the corresponded VT key sequence.
    - added StrictKeyMapping entry in teraterm.ini file.
  - Added the Visual C++ version and the built time on About TeraTerm dialog.
  - added `sprintf2' macro command.
  - added `waitn' macro command. Special thanks to p3g4asus.
  - added the result of "logopen" macro command stores to 'result' variable.
  - added "mtimeout" macro variable. When a user uses the wait-related macro, Tera Term waits "timeout * 1000 + mtimeout" millisecond. Precision is about 50 msec.
  - added `sendbroadcast' macro command.
  - added `sendlnbroadcast' macro command.
  - added `sendmulticast' macro command.
  - added `setmulticastname' macro command.
- Bug fixes
  - Bug fix: In the Cygwin connection, PATH environment variable is truncated to 1024 bytes.
  - Bug fix: added the workaround that a developer can debug the Tera Term macro script on Visual Studio.
  - Bug fix: connect macro can not finish when /DS is specified.
  - Bug fix: By using logopen macro with the hidden option, the log window appears for a quick moment.
  - Bug fix: When the reverse video mode is enabled, DECSCNM is on, the character and background color configuration does not work.
  - Bug fix: When the reverse video mode is enabled, DECSCNM is on, the character and background color does not restore after saving and loading the configuration.
- Misc
  - upgraded TTSSH version supporting SSH2 to 2.50
  - upgraded TTX KanjiMenu Plug-in to 0.1.5.
  - upgraded cyglaunch to 1.01
  - added support for Microsoft Windows 95.
  - added limited support for Microsoft Windows 7 beta(build7000).

### 2008.12.16 (Ver 4.61)

- Changes
  - disabled the Plain text and Timestamp flag when the Binary flag is enabled.
  - added the display method of Accept Window Title Change Request. The title can insert before or after the canonical title.
  - moved the "Delimitter Characters" configuration from "General" tab to "Copy and Paste" tab on the "Additional settings" dialog.
  - added the /DS command line option. It disables the "New connection" dialog.
  - Preserved the comment and the position of the entry in teraterm.ini file when a user saved the Tera Term configuration.
  - added support for replace the command of UK character set with the US-ASCII. This is the workaround that the lower-case alphabet can not properly display after showing DEC special character.
  - added 'gethostname' macro command.
- Bug fixes
  - Bug fix: The following problems about the character attribute. These bugs were introduced in 4.58.
    - The high brightness, the under line, the blinking and the reverse attribute apply in the erase area.
    - On the Edit menu and then point to clear screen and clear buffer, the terminal screen is cleared with the current background color.
    - The display after clearing the screen could not synchronize with the buffer by using ED(Erase in Display) and EL(Erase in Line).
    - The character attribute uses by using DECALN(DEC Screen Alignment Test).
  - Bug fix: The macro label can be specified the characters other than alphabet and numeric ones.
  - Bug fix: Using the filestrseek2 macro command, a file pointer is minus value if the matched string locates at one byte in the file.
  - Bug fix: Using the logopen macro command, when the specified filename does not include \ character, the log file is saved at the root directory.
  - Bug fix: Using the gettitle macro command, Tera Term could not get an entire string when the window title is longer than 31 bytes.
  - Bug fix: strmatch macro command does not work.
- Misc
  - Modified Tera Term installer script
    - added ssh:// associated with the ttermpro.exe.
    - added some plug-ins in the Additional Plug-ins.
    - moved the TTXKanjiMenu plug-in to the Additional Plug-ins.
    - added the cygterm+ source code in Tera Term package.
  - upgraded TTSSH version supporting SSH2 to 2.49
  - upgraded CygTerm+ to 1.07_16

### 2008.9.23 (Ver 4.60)

- added support of CHT (Cursor Forward Tabulation) and CBT (Cursor Backward Tabulation) control sequence.
- added support for Visual Bell. When Tera Term receive the BEL character, the window can flash instead of sounding the beep.
  - added the Visual option of Beep entry in teraterm.ini file.
- added support for Korean language. Special thanks to Keonsoon Hwang.
- added the error message when a user can not open a log file. However, the logopen macro does not show the error message.
- added support for receiving the escape sequence regarding the code can change the window title.
  - added AcceptTitleChangeRequest entry in teraterm.ini file. The default is ON.
  - added the check box on Additional settings dialog.
- added support for changing the size of the ConfirmChangePaste dialog.
- added support for saving the size of the ConfirmChangePaste dialog to teraterm.ini file.
  - added PasteDialogSize entry in teraterm.ini file. The default value is 330x230.
- added support for displaying the terminal size after resizing on the tool tip.
- added support for the progress indicator on the file transfer dialog.
- added the workaround for a lot of pasting data would corrupt on SSH2 connection. This workaround is 10msec waiting with each 500 byte.
- added support for canceling the `messagebox' and the `yesnobox' macro command. When a user cancels the messagebox window, the macro engine halts.
- added support for the TTX interface to hook the serial communication.
- added 'crc32' and crc32file macro command.
- added 'getttdir' macro command.
- Bug fix: A user could not duplicate the network session of TELNET and SSH without port 22 and 23.
- Bug fix: The terminal size could reduce on Windows 98-compatible products.
- Bug fix: Tera Term icon would 16x16 size when a user changes the window by using Alt+Tab key on Windows Vista Aero.
- upgraded TTSSH version supporting SSH2 to 2.48

### 2008.6.25 (Ver 4.59)

- Changed the application name from "UTF-8 TeraTerm Pro with TTSSH2" to "Tera Term".
  - We will encourage the introduction by uninstallation and a new installation.
- added Windows XP x64, Windows Vista and Windows Server 2008 to the supported OSes list.
- updated to new Tera Term icon file(teraterm.ico, vt.ico) and macro icon file(ttmacro.ico). Special thanks to Tatsu Sakamoto.
- Pasting by clicking the middle button of mouse has been deleted in last release, but put it back.
  - added DisablePasteMouseMButton entry in teraterm.ini file. The default value is on.
- changed Additional settings dialog.
  - added ConfirmChangePaste option.
  - added MouseEventTracking option.
  - Moved from the partial content of General tab sheet to the new 'Copy and Paste' tab sheet.
  - Bug fix: Not saving the others tab content.
  - Bug fix: Can not create the `cygterm.cfg' file when the file does not exist.
  - Bug fix: The invalid error message would be shown when the default log file name is not specified.
- added support for display confirmation dialog when 'Paste<CR>' menu was selected.
- added the user configuration for the mouse wheel scroll line.
  - added MouseWheelScrollLine entry to teraterm.ini. The default value is 3.
  - added a edit control on Additional settings dialog.
- added support for memorializing previous .ttl file directory.
- added support for hiding [LogMeTT] under [File] menu when LogMeTT.exe does not exist.
- added support for configuring the ScrollLock key in KEYBOARD.CNF file.
  - added ScrollLock entry in KEYBOARD.CNF file. The default value is 70.
- added support for configuring whether the current buffer would be scrolled out with <ESC>[J clear screen.
  - added ScrollWindowClearScreen entry in teraterm.ini file. The default value is on.
- Prevented automatically scroll out other than the latest bottom line (Not reset scroll-back on display activity). However, the scroll-back will be reset when a user inputs any key (except control keys such as CTRL and SHIFT). Special thanks to Salarm.
  - added AutoScrollOnlyInBottomLine entry to teraterm.ini. The default value is on.
  - added a check box on Additional settings dialog.
- added support for the configuration whether the Unicode character that Tera Term does not support treated as a wide character.
  - added the UnknownUnicodeCharacterAsWide entry in teraterm.ini file. The default value is off.
- If a received Kanji code is either UTF-8 or UTF-8m, some characters such as a ruler and special characters will be displayed by using similar characters in DEC special character set. These characters are categorized into several groups and you can specify each group to be converted or not.
  - added the UnicodeToDecSpMapping entry in teraterm.ini file. The default value is 3.
- added specifying the default file name as the sending file name when a file specified by FileSendFilter.
- added the ASCII string of the hex-dump in X and ZMODEM log file.
  - added YmodemLog in teraterm.ini file. The default value is off. Currently, Tera Term not supporting YMODEM protocol.
- added 'strmatch' macro command.
- added 'setrts' and 'setdtr' macro command.
- added support for WM_COPYDATA message continuous transmission by using the Broadcast Command. Special thanks to Salarm.
- added support for changing the window icon of VT and TEK.
  - added the VTIcon and TEKIcon entry in teraterm.ini file. The default value is "Default".
  - added the /VTICON and /TEKICON command line option.
  - added setting up the CygTerm icon on VT window by launching CygTerm(This feature is enabled on a new installation).
    added the `/VTIcon=CygTerm' command line option in TERM entry of cygterm.cfg.
- Moved the confirmation dialog of ConfirmChangePaste from the mouse cursor to the current caret position.
- The work selection by double-clicking was enabled when the mouse tracking mode is used.
- Maximum number of tracked host name in New Connection dialog is increased from 99 to 200.
- Modified Tera Term installer script
  - added the cyglaunch shortcut to the startup menu.
  - added the cyglaunch shortcut to the quick launch bar.
  - linked .ttl file to the ttpmacro.exe program.
  - linked telnet protocol to the ttermpro.exe program.
  - updated FileDir entry in the teraterm.ini file to Tera Term installation directory.
- Bug fix: "Window list" dialog was not appeared in VT window.
- Bug fix: Some application like as LogMeTT.exe and cygterm.exe, or cygterm.cfg file would not work well when Tera Term current directory is changed because the full-path does not be specified.
- Bug fix: XModemRcvCommand entry in teraterm.ini file could not be empty.
- Bug fix: Invalid position could be notified with the mouse event tracking.
- Bug fix: Could not automatically connect with the serial line when both "/C=" and "/M=" options are specified at ttermpro.exe.
- Bug fix: The control sequence by using C1 control character could not work well when the receiving KANJI code is UTF-8 or UTF-8m.
- Bug fix: Changing the window title with the control sequence would not work well when the receiving KANJI code is SJIS.
- Bug fix: The background color and ANSI color configuration would not work well when a user specify /F= option on "New Connection" dialog.
- Bug fix: Tera Term window would not display when a user pushes OK button on "Additional Settings" dialog with Eterm look-feel enabled.
- Bug fix: Tera Term window would be shifted down from the top of the external monitor and aligned to the top of the primary monitor when the window maximizes on the dual monitor.
- Bug fix: The edge of Tera Term window would protrude in the external monitor when the window maximizes on the dual monitor.
- Bug fix: fixed a problem that MaxBroadcatHistory allows up to 99 although more than 100 can be specified.
- upgraded TTSSH version supporting SSH2 to 2.47
- upgraded TeraTerm Menu to 1.08
- upgraded LogMeTT to 2.9.4

### 2008.2.29 (Ver 4.58)

- Rotating the mouse wheel would supersede the cursor key when the application cursor mode is enabled.
  - added TranslateWheelToCursor entry in teraterm.ini file. The default value is on.
- added the configuration entry to whether "New Connection" dialog is shown on TeraTerm startup.
  - added HostDialogOnStartup entry in teraterm.ini file. The default value is on.
- added support of mouse event tracking.
  - added MouseEventTracking entry in teraterm.ini file. The default value is on.
- added the "Realtime mode" feature on Broadcast Command. This feature can send all user's key sequence to TeraTerm window, and then a user can use vi editor on all window. This feature takes after "TeraTerm Pro assistant" free ware in lots of ways.
  - added "Realtime mode" check-box in Broadcast Command dialog. The default is on.
  - added a TeraTerm window list. Also, a user can select all item or cancel all item by double-click(toggle).
  - Broadcast Command dialog is moved to the upper of TeraTerm window.
- displayed the cursor bitmap when TeraTerm window loses the keyboard focus.
  - added KillFocusCursor entry in teraterm.ini file. The default value is on.
- added the configuration entry to whether "Log" transfer dialog is shown on start logging.
- added the "SCP" button on the confirmation dialog when a user drags a file to TeraTerm window.
- added Font linking fixed patch. Special thanks to naoh.
- added the confirmation dialog when the Clipboard includes CR/LF by right-click or Alt+V. This is a foolproof way.
  - added ConfirmChangePaste entry in teraterm.ini file. The default value is on.
- added the configuration entry to save the window position.
  - added SaveVTWinPos entry in teraterm.ini file. The default value is off.
- changed the default value of TermType from 'vt100' to 'xterm'
  - TERM environment variable is reported as "xterm" to the host by using TELNET and SSH protocol.
- disabled pasting with clicking the middle button of mouse.
- changed default folder of the dialog to select a folder. The current path of configuration is selected.
- increased max width of window from 300 chars to 500 chars.
- added support for 256 xterm color and 16 aixterm color mode.
  - added Xterm256Color and Aixterm16Color entry in teraterm.ini file.
  - changed from FullColor entry to PcBoldColor entry.
  - added new check-boxes on setup window dialog.
- changed from the standard background color to the current background color on the line and the screen deleted area, the new displayed line by scrolling.
- added the German.lng language file. Special thanks to Alexander Wiechert.
- added the workaround for corrupting the character line on the Maximize window.
  - added MaximizedBugTweak entry in teraterm.ini file. The default value is on.
- Bug fix: Reverse video control sequence (DECSCNM) doesn't work correctly.
- Bug fix: When TeraTerm is the Maximize window, TerminalSize entry in relation to the window would be recorded in teraterm.ini file.
- Bug fix: The problem that a multi-byte character string which includes 0x5C and/or 0x7C is recognized as invalid is now fixed. This problem existed in a routine to check a file name.
- Bug fix: TeraTerm COM auto connect problem. Special thanks to Steven Yang. cf. TeraTerm com auto connect bug
- Bug fix: ANSI Color settings is not immediately reflected.
- Bug fix: Too many '\' characters could be shown after changing the title string by the escape sequence.
- added 'getver' macro command.
- added 'setbaud' macro command. Special thanks to Steven Yang.
- added three parameters from 6 to 8 in 'showtt' macro command. Special thanks to Steven Yang.
- added the second parameter in 'exec' macro command. Special thanks to Steven Yang.
- added new arguments <plain text flag>, <timestamp flag>, <hide dialog flag> to 'logopen' macro command.
- if 'getdate' and 'gettime' macro command have no date and time format, system variable "result" is not changed. (for compatibility with version 4.56 or earlier)
- upgraded TTSSH version supporting SSH2 to 2.46
- upgraded TTProxy to 1.0.0.15
- upgraded TTX KanjiMenu Plug-in to 0.1.4.

### 2008.1.15 (Ver 4.57)

- added param4 to param9 macro command line parameters.
- added ESC key binding on Additional settings dialog.
- added Enter key binding on Additional settings dialog.
- added support for ZMODEM sending file with the time-stamp and permission(0644) of the file.
  - added ZmodemRcvCommand entry in teraterm.ini which is ZMODEM receive program. The default is "rz".
- added support for sending "rx filename" command sequence to the connected host before sending the local file with XMODEM protocol.
  - added XmodemRcvCommand entry in teraterm.ini which is XMODEM receive program. The default is "".
- added 'cygconnect' macro command.
- added new argument to getdate and gettime macro command. It specifies date and time format.
- added 'scpsend' macro command.
- added 'scprecv' macro command.
- added the user confirmation when a file drags to TeraTerm window.
  - added ConfirmFileDragAndDrop entry in teraterm.ini file. The default value is off.
- Bug fix: TeraTerm would overwrite the selected buffer to the Clipboard when SelectOnlyByLButton entry is on.
- Bug fix: extension filters on file dialog didn't work when the FileSendFilter is specified.
- Bug fix: double close a local file handle when same file already exists on the remote host by sending the local file with ZMODEM protocol.
- Bug fix: Telnet keep-alive mechanism could not been thread-safe.
- Bug fix: New-line (transmit) of Terminal Setup would be empty when a user connects.
- Bug fix: Up and Down key could not work with DELL USB keyboard. Added the workaround. Special thanks to chuckf.
  cf. http://www.neocom.ca/forum/viewtopic.php?p=2565
- upgraded TTSSH version supporting SSH2 to 2.45
- upgraded CygTerm+ to 1.07_14
- upgraded Oniguruma to 5.9.1

### 2007.12.4 (Ver 4.56)

- added new optional setting that can disable application keypad/cursor mode.
  - added DisableAppKeypad and DisableAppCursor entry to teraterm.ini.
  - added a check box on Keyboard setup dialog.
- added new optional setting that can cleaning COM buffer when port opening.
  - added ClearComBuffOnOpen entry to teraterm.ini. On is clear buffer, or Off is not clear buffer. The default value is on.
- added support Ctrl+u shortcut key in "Host" drop-down on "New connection" dialog. The shortcut key is deleting backward from point to the beginning of the line.
- added /BAUD command line option to specify baud rate of serial port.
- added support sending C1 control characters as single 8-bit characters.
  - added Send8BitCtrl entry to teraterm.ini. The default value is off.
  - added support of S7C1T/S8C1T control sequences.
  - added support of changing C1 control mode by DECSCL control sequence.
- added support for KAM(Keyboard Lock) and DECNKM(numeric keypad mode) control sequences.
- added an open dialog to select a folder at "Change directory" menu under file menu.
- added support for enabling only mouse left-click to select the text by dragging.
  - added SelectOnlyByLButton entry to teraterm.ini. The default value is on.
  - added a check box on Additional settings dialog.
- On UTF-8 encoding, single COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK(U+3099) and COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK(U+309A) are displayed as KATAKANA-HIRAGANA VOICED SOUND MARK(U+309B) and KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK(U+309C).
- add support of handling large text data in clipboard to macro command clipb2var.
  - added new argument to macro command clipb2var. It controls start position of copying.
  - if clipboard content is too long and copied string was truncated, clipb2var returns 2 in system variable "result".
- added 'do', 'loop' macro command.
- added 'until', 'enduntil' macro command.
- added 'callmenu' macro command.
  - added `screencapture.ttl' file as a sample TTL macro.
- added new optional setting that can disable telnet command detection.
  - added TelAutoDetect entry to teraterm.ini. default is on.
- added 'Cancel selection' new menu under edit menu.
- changed the initial directory of log file to 'Default Log Save Folder' when it is available.
- Bug fix: the transparency of window could not change to 255.
- Bug fix: last 1 character of title string that is sent from server is deleted.
- Bug fix: TeraTerm would use the configuration of TCPLocalEcho/TCPCRSend when the user start telnet connection on New connection dialog.
- Bug fix: when continued line copy is enabled, Copy Table does not work correctly
- Bug fix: when Transmit DEL by Delete key is enabled and Num Lock status is off, Numeric Keypad "." sends DEL.
- Bug fix: 'wait' macro command can't wait a long string. This bug was introduced in 4.54.
- Bug fix: The color value on Window setup dialog would become 255 when the value is less than 16 and the user pushes PageUP key.
- Bug fix: COM port description would be wrong when COM port number is forced to switch another number. Special thanks to xoxo-san.
- Bug fix: On TEK Window's Setup Window dialog, "Always use Normal text's BG" check-box is displayed.
- Bug fix: TEK Window's Setup Font dialog does not support for dynamic loading of user interface messages.
- upgraded TTSSH version supporting SSH2 to 2.44
- upgraded TeraTerm Menu to 1.07

### 2007.10.14 (Ver 4.55)

- added reporting the stack trace and register dump of TeraTerm process when the application error occurs.
- added support Ctrl+d, Ctrl+k shortcut key in "Host" drop-down on "New connection" dialog. The former is deleting the character at point and the latter is killing the text from point to the end of the line.
- expanded the maximum number of serial connection to 256.
- changed the default value of "Bold style font" to On.
- Bug fix: 'getdir' macro command caused crash.
- Bug fix: the format of strftime in log filename was not extracted.
- upgraded TTSSH version supporting SSH2 to 2.43

### 2007.9.30 (Ver 4.54)

- added support for selecting a current screen buffer. Also, added `select screen' new menu under edit menu.
- added support for showing the device description of COM port on the connection dialog.
- added support of telnet keep-alive.
  - TeraTerm will send TELNET NOP command to host when no communication does for a long time.
  - added TelKeepAliveInterval entry in teraterm.ini file. The default value is 300 per seconds. 0 is turn off.
  - added telnet keep-alive input box on TCP/IP setup dialog.
- added Alt+I accelerator key as disconnect.
- added shift operator ">>", "<<", ">>>" for macro.
- changed the priority of macro operator in the following order:

  -     New:
        Priority Operator
        1       not ~ ! +(unary) -(unary)
        2       * / %
        3       + -
        4       >> << >>>
        5       and &
        6       xor ^
        7       or |
        8       < > <= >=
        9       = == <> !=
        10      &&
        11      ||

        Old:
        Priority Operator
        1       not ~ ! +(unary) -(unary)
        2       * / %
        2       and &
        3       + -
        3       or xor | ^
        4       = <> < > <= >=
        5       &&
        6       ||

- added 'rotateleft', 'rotateright' macro command.
- added 'setenv' macro command.
- added 'filenamebox' macro command.
- expanded the maximum number of serial connection to 200.
- changed the initial directory of log file to any directory.
- add support Ctrl+p, Ctrl+n, Ctrl+b, Ctrl+f, Ctrl+a and Ctrl+e shortcut key in "Host" drop-down on "New connection" dialog. Shortcut keys are compatible with up-arrow, down-arrow, left-arrow, right-arrow, Home and End key.
- stopped saving VTPos and TEKPos when saving teraterm.ini.
- changed the save file for the history of broadcast command to broadcast.log.
- added setting of the number for the history of broadcast command.
  - added MaxBroadcatHistory entry to teraterm.ini.
- added new argument to macro command 'messagebox', 'yesnobox', 'inputbox', 'passwordbox' and 'statusbox'. It controls whether to parse '\n','\t' as special characters.
- Bug fix: window size could not be changed at first time.
- Bug fix: CR+LF code at the end of line would not been selected when you select "Select all" menu under edit menu.
- Bug fix: Mouse wheel would not be rotated on Windows Vista.
- Bug fix: Kermit fails to properly negotiate to NOT use "repeat" compression when talking to a primitive partner. Special thanks to Anders Larsen.
- replaced internal string functions to secure functions.
  - deleted _CRT_SECURE_NO_DEPRECATE build option.
- upgraded TTSSH version supporting SSH2 to 2.42
- upgraded TeraTerm Menu to 1.06
- upgraded TTProxy to 1.0.0.14

### 2007.8.8 (Ver 4.53)

- added `&h' parameter to log file name that can convert the host name.
- added a default log directory setting.
  - added LogDefaultPath entry to teraterm.ini.
  - added a new edit control on Additional Settings tab.
- added auto start logging setting when a user try to connect.
  - added LogAutoStart entry to teraterm.ini.
  - added a new check-box on Additional Settings tab.
- added the file name filter on the file sending dialog.
  - added FileSendFilter entry to teraterm.ini.
- changed the behavior of tab at end-of-line. It causes linefeed automatically.
  - added VTCompatTab entry to teraterm.ini. This entry enables the behavior of the tab code at end-of-line to doing as vt100/xterm. The default is off.
- expanded the maximum number of serial connection to 200.
- added support displaying the port number of TCP and the baud rate of serial port to titlebar.
- added support for Click-able URL to Emacs editor. TeraTerm would ignore \ character as URL composition characters when an end of a line was the character.
- added 'tolower' macro command.
- added 'toupper' macro command.
- added 'break' macro command.
- added an argument to inputbox macro command. New argument is used for default input string.
- added logical operator "&&", "||", "!" and bitwise operator "&", "|", "^", "~" for macro.
- added "Cygterm Here" to a context menu of Explorer. CygTerm can be started from an any directory on Explorer.
  - added cyglaunch.exe program that was able to start CygTerm without adding `X:\cygwin\bin' to PATH environment variable.
- changed the owner of HTML help file from TeraTerm instance to Windows desktop.
- changed the macro error does not occur when including the empty macro file.
- added to preserve comment and unknown parameter when saving cygterm.cfg file.
- added to disable the serial port in New Connection dialog when there is no available COM ports.
- deleted hlp style help files(ttermp.hlp).
- Bug fix: eliminated a unnecessary return code every time 1KB logging with the time-stamp mode. Special thanks to Gentaro.
- Bug fix: BOF(Buffer Over Flow) problem in ttpmacro.exe program, which 256 byte longer command line parameter is specified.
- Bug fix: BOF(Buffer Over Flow) problem in ttpmacro.exe program when a line of macro is longer than 256 byte.
- added a workaround that ttermpro.exe can not send the server data to ttpmacro.exe with DDE transaction.
- Bug fix: wrong free of memory in var2clipb macro command.
- Bug fix: did not save/load "LF" to CRReceive entry in teraterm.ini.
- Bug fix: TeraTerm window size could not be changed after the window size is smaller than 120 dot(94 dot on XP LUNA style). This is TeraTerm 2.3 original bug.
- Bug fix: status-box does not display '\n' as LF when the status-box is existing yet.
- Bug fix: some macros are not become an error when the parameter filename starts by ':'.
- Bug fix: the expression like "a < b < c" cannot be evaluated by the macro.
- Bug fix: The control window of ttpmacro.exe would be unresponsive while doing `pause' macro command.
- added TTX KanjiMenu Plug-in 0.1.3(ttxkanjimenu.dll). Special thanks to Sunao HARA.
- upgraded TTSSH version supporting SSH2 to 2.41
- upgraded CygTerm+ to 1.07_13
- upgraded LogMeTT to 2.9.2
- upgraded Oniguruma to 5.9.0

### 2007.5.7 (Ver 4.52)

- Bug fix: yesnobox macro showed tow 'OK' buttons.
- Mouse cursor and ANSI color settings are moved to Visual tab in Additional settings dialog.
- added new optional setting that can confirm pasting by right click.
  - added ConfirmPasteMouseRButton entry to teraterm.ini.
  - added a check box on Additional settings tab.
- added new optional setting that can disable accelerator key of Send break.
  - added DisableAcceleratorSendBreak entry to teraterm.ini.
  - added a check box on Additional settings tab.
- added "ParentOnly" check box on Broadcast dialog. The check box enables the sending target from Broadcast dialog is restricted to parent window. Special thanks to 337.
- added new optional setting that can disable Broadcast sending from Broadcast dialog(parent window).
  - added AcceptBroadcast entry to teraterm.ini.
  - added a check box on Additional settings tab.
- When the connection is SSH or Cygwin, TCPLocalEcho setting and TCPCRSend setting is not used.
  - added /E command line option.
- Bug fix: LOGIN_SHELL and HOME_CHDIR were removed when saving cygterm.cfg from Additional settings dialog.
- Bug fix: some file select dialogs are not displayed on Windows NT 4.0.
- added `sprintf' macro command.
- added `str2int' macro command support for hexadecimal conversion.
- upgraded TTSSH version supporting SSH2 to 2.40
- upgraded TTProxy to 1.0.0.13
- upgraded LogMeTT to 2.9.1
  - Standalone TeraTerm Macro Editor - TTLEditor was added.
- upgraded Oniguruma to 5.7.0

### 2007.3.10 (Ver 4.51)

- Bug fix: some file select dialogs are not displayed on Windows98/NT4.0.
- Bug fix: the 'pause' macro command had a time-lag about 1 sec.
- TeraTerm reads the teraterm.ini from My Documents when it exists.
- Selected the next line including word characters if double-clicked word character is over the most right line when EnableContinuedLineCopy is enabled.
- added support for saving Broadcast Command history in teraterm.ini file.
- added support for serial port dynamic detection. TeraTerm could detect available COM ports and display only possible in 'New connection' and 'Serial port setup' dialog.
- added support for dynamic loading of user interface messages.
  - added Japanese language message file.
  - added UILanguageFile entry to teraterm.ini.
- upgraded TTSSH version supporting SSH2 to 2.39
- upgraded CygTerm+ to 1.07_11
- upgraded TTProxy to 1.0.0.12
- upgraded TeraTerm Menu to 1.05
- upgraded Oniguruma to 5.5.3

### 2007.1.22 (Ver 4.50)

- TeraTerm source code have been rebuilt with Visual Studio 2005 Standard Edition(+SP1).
- Bug fix: The macro script might stall with logging mode. This is TeraTerm 2.3 original bug.
  The reason of the bug is that DDE server does not send the data to DDE client because log buffer index does not match DDE buffer index.
- Bug fix: TeraTerm crashes when the log file name is not a full path.
- Bug fix: The return code doesn't have been recorded in log file if EnableContinuedLineCopy is enabled.
- added FUNCTION.CNF. F1-F10 keys are enabled in this keyboard setup file.
- added 'Replay Log..' menu under File menu. This function replays log with binary mode and emulates the escape sequence.
- Connecting socket could be canceled after the specified value timeout.
  - added `ConnectingTimeout' entry in teraterm.ini file. This value is connecting timeout per seconds.
  - Also added `/timeout=' command line option.
  Conversely, no action if the value is zero(depends on Windows TCP/IP stack implementation).
- added `LF' to New-line Receive on Terminal setup dialog.
  TeraTerm considers the server new-line is LF if the option is selected and treats it as CR+LF.
  cf. http://www.neocom.ca/forum/viewtopic.php?t=216
- upgraded TTSSH version supporting SSH2 to 2.38
- upgraded TTProxy to 1.0.0.10
- upgraded Oniguruma to 5.5.2

### 2006.11.20 (Ver 4.49)

- Bug fix: TeraTerm(DDE server) sent the invalid return value to TeraTerm macro(DDE client) when DDE server was received XTYP_POKE message.
- added busy procedure(DDE_FBUSY) between DDE server and DDE client.
- added support for ScrollLock key.
- added support for XMODEM-1K send with checksum when the peer specifies it instead of CRC. Special thanks to Mark Deneen.
- updated HTML help document.
- changed installer. teraterm.ini entries (Language, Locale, CodePage. VTFont and TEKFont) are set by installer when new install.
- upgraded TTSSH version supporting SSH2 to 2.37
- upgraded Oniguruma to 4.5.1

### 2006.11.1 (Ver 4.48)

- added 'fileread' macro command. This command enables the macro script to read the specified bytes from file.
- upgraded TTSSH version supporting SSH2 to 2.36
- upgraded Oniguruma to 4.4.6

### 2006.10.28 (Ver 4.47)

- deleted duplication of accelerator key bind under File menu.
- Workaround: insert 1msec sleep to OnIdle engine while DDE buffer is full.
- deleted 100msec sleep after send and sendln macro command.
- expanded the ring buffer size of macro program(ttpmacro.exe) from 4KB to 16KB. And also changed the macro synchronization timing to TeraTerm(ttermpro.exe).
- upgraded TTSSH version supporting SSH2 to 2.35
- upgraded LogMeTT to 2.8.6
- upgraded Oniguruma to 4.4.5

### 2006.10.9 (Ver 4.46)

- Bug fix: default save directory of teraterm.ini is set to desktop on Windows Vista.
- added 'clipb2var' macro command. This command enables the macro script to get data from clipboard.
- added 'var2clipb' macro command. This command enables the macro script to set data to clipboard.
- Bug fix: /L= parameter in New Connection dialog is not used on first TeraTerm window.
- added 'ifdefined' macro command. This command returns the type of variable.
- updated HTML help document.
- upgraded TTSSH version supporting SSH2 to 2.34
- upgraded CygTerm+ to 1.06_11
- upgraded Oniguruma to 4.4.4

### 2006.9.16 (Ver 4.45)

- add default log filename setting.
  - added new edit control to 'Additional settings' dialog.
  - added LogDefaultName entry in teraterm.ini file.
  - expanded the log filename which can include a format of strftime.

        SYNOPSIS:
        %a	Abbreviated weekday name
        %A	Full weekday name
        %b	Abbreviated month name
        %B	Full month name
        %c	Date and time representation appropriate for locale
        %d	Day of month as decimal number (01 - 31)
        %H	Hour in 24-hour format (00 - 23)
        %I	Hour in 12-hour format (01 - 12)
        %j	Day of year as decimal number (001 - 366)
        %m	Month as decimal number (01 - 12)
        %M	Minute as decimal number (00 -  59)
        %p	Current locale's A.M./P.M. indicator for 12-hour clock
        %S	Second as decimal number (00 - 59)
        %U	Week of year as decimal number, with Sunday as first day of week (00 - 53)
        %w	Weekday as decimal number (0 - 6; Sunday is 0)
        %W	Week of year as decimal number, with Monday as first day of week (00 - 53)
        %x	Date representation for current locale
        %X	Time representation for current locale
        %y	Year without century, as decimal number (00 - 99)
        %Y	Year with century, as decimal number
        %z, %Z	Either the time-zone name or time zone abbreviation, depending on registry settings;
        	no characters if time zone is unknown
        %%	Percent sign

- disable automatically connection to serial port on startup when /M command line parameter is specified.
- updated HTML help document.
- upgraded TTSSH version supporting SSH2 to 2.33
- upgraded CygTerm+ to 1.06_08
- upgraded Oniguruma to 4.4.1

### 2006.8.19 (Ver 4.44)

- Bug fix: 'ttpmacro.exe' terminated after startup on Windows98/NT4.0.
- added the mutex object to ttermpro.exe, ttpmacro.exe, ttpmenu.exe, keycode.exe and cygterm.exe.
- Changed TeraTerm installer software to InnoSetup.
- updated HTML help document.
- upgraded TTSSH version supporting SSH2 to 2.32
- upgraded CygTerm+ to 1.06_06

### 2006.8.4 (Ver 4.43)

- expanded the number of macro variables which can be used as user variable from 241 to 256. This is bug because some variables were used as system variable.
- expanded the input box dialog of macro. It is resized automatically when the message is long than default size.
- changed '\n' character not raw character but meta character as LF code.
- changed the message box of macro from dialog border to re-sizable.
- set '23' to port number when the host name start with 'telnet://' and port number was not specified.
- upgraded TTSSH version supporting SSH2 to 2.31
- upgraded TTProxy to 2006/8/23 version. Special thanks to YebisuyaHompo.

### 2006.7.26 (Ver 4.42)

- updated to new TeraTerm icon file(teraterm.ico, vt.ico). Special thanks to Tatsu Sakamoto.
- upgraded TTSSH version supporting SSH2 to 2.30
- upgraded LogMeTT to 2.8.5
- Bug fix: Collector resource English text.

### 2006.7.24 (Ver 4.41)

- added time-stamp option on log saving dialog. And also added LogTimestamp entry in teraterm.ini file.
- upgraded Kantan Installer version to 2.30a. The installer could record the previous installed folder when TeraTerm installation package was upgraded.
- Bug fix: Collector resource English text.
- upgraded Oniguruma to 4.2.0

### 2006.7.19 (Ver 4.40)

- upgraded both ttermpro.exe and ttpmacro.exe version information.
- updated HTML help document.
- upgraded LogMeTT to 2.8.4

### 2006.7.1 (Ver 4.39)

- Bug fix: UTF-8 miss decoding when the one byte character(ASCII) comes after the two byte characters.
- changed Copyright string.

### 2006.6.23 (Ver 4.38)

- updated HTML help document.
- upgraded TTSSH version supporting SSH2 to 2.28

### 2006.6.18 (Ver 4.37)

- Bug fix: Title string could not been shown as Japanese character from TeraTerm setup dialog. Special thanks to NAGATA Shinya.
- upgraded TTSSH version supporting SSH2 to 2.27
- Bug fix: Collector resource English text.

### 2006.6.11 (Ver 4.36)

- upgraded TTSSH version supporting SSH2 to 2.26

### 2006.5.25 (Ver 4.35b)

- added 'Collector 3.2.3'(tabbed multi window tool) to TeraTerm installation package. Special thanks to Hiroshi Takahashi.

### 2006.5.7 (Ver 4.35a)

- upgraded TTSSH version supporting SSH2 to 2.25

### 2006.4.7 (Ver 4.35)

- changed the owner of HTML help file from TeraTerm instance to Windows desktop.
- upgraded TTSSH version supporting SSH2 to 2.24

### 2006.4.4 (Ver 4.34)

- upgraded TTSSH version supporting SSH2 to 2.23

### 2006.4.1 (Ver 4.33)

- Bug fix: TeraTerm window flickers though the user doesn't use transparency window.

### 2006.3.30 (Ver 4.32)

- upgraded TTSSH version supporting SSH2 to 2.22

### 2006.3.28 (Ver 4.31)

- enabled the transparency value of TeraTerm window to immediately changing on Additional settings dialog.
- Bug fix: The background color of text matches the background color of screen patch. Special thanks to 337.
- enabled VisualStyle feature on WindowsXP.
- deleted one millisecond sleep on VT window.
- changed TeraTerm Help file from .hlp to .chm style.
- upgraded TTSSH version supporting SSH2 to 2.21
- upgraded LogMeTT to 2.8.3

### 2006.3.6 (Ver 4.30)

- upgraded ttpmacro.exe version information.
- upgraded TTSSH version supporting SSH2 to 2.20

### 2006.3.3 (Ver 4.29)

- added the background color of text matches the background color of screen.
  - added "Always use Normal text's BG" check-box on Window setup dialog.
  - added UseNormalBGColor entry in teraterm.ini file.
  Special thanks to 337.
- Bug fix: don't work the font copying batch file on Windows9x. Special thanks to Takashi SHIRAI.

### 2006.2.24 (Ver 4.28)

- changed the compiler to Visual Studio 2005 Standard Edition.
- replaced stricmp() to _stricmp().
- replaced strnicmp() to _strnicmp().
- replaced strdup() to _strdup().
- replaced chdir() to _chdir().
- replaced getcwd() to _getcwd().
- replaced strupr() to _strupr().
- deleted compiler warning message for time_t has 64bit size.
- added the color change on Window setup dialog was in real time done.
- limited the macro commands displaying on macro window for the speed-up of the macro operation.
- upgraded TTSSH version supporting SSH2 to 2.19
- upgraded TeraTerm Menu to 1.0.4
  - fixed build error with VS2005.
  - updated version information in .exe file.
- upgraded Oniguruma to 4.0.1

### 2006.2.11 (Ver 4.27)

- expanded the number of macro variable from 128 to 256 and the number of macro label from 256 to 512.
- added the workaround about CPU load goes up to 100% using 'pause' macro on TEK active window.
- deleted 'TeraTerm Menu' under File menu.
- fixed the flicker phenomenon of TeraTerm window when 'Broadcast Command' is used.
- changed the accelerator key bind under Setup menu.
- added 'mpause' macro command. This command enables the macro script to pause the specified time in millisecond.
- added the sample TTL macro 'mpause.ttl'.
- added 'random' macro command. This command enables the macro script to generate the random value.
- added the sample TTL macro 'random.ttl'.
- upgraded CygTerm to 1.06_02. Special thanks to BabyDaemon.

### 2006.1.21 (Ver 4.26)

- added the user confirmation dialog before sending file content with Drag and Drop to TeraTerm window.
- upgraded LogMeTT to 2.8.1
- upgraded Oniguruma to 3.9.1

### 2005.12.13 (Ver 4.25)

- Bug fix: can't save TeraTerm configuration to ini file without 'teraterm.ini' filename.

### 2005.12.1 (Ver 4.24)

- expanded serial connection maximum to COM99.
- added new serial baud rate(230400, 460800, 921600).
- upgraded LogMeTT to 2.7.4

### 2005.11.3 (Ver 4.23)

- added checking the writable permission if saving teraterm.ini file.
- changed "Term type" edit box on TCP/IP setup dialog to be always enabled.

### 2005.10.21 (Ver 4.22)

- added the system variable from 'groupmatchstr1' to 'groupmatchstr9' which will store the group matched pattern with regular expression.
- added duplicating Cygwin connection using Alt + D accelerator key.
- Bug fix: DAKUTEN(the dot marks) might not be correctly shown in UTF-8 for Mac OS X.
- upgraded TTSSH version supporting SSH2 to 2.18
- Bug fix: TeraTerm Menu pop-up menu couldn't be shown at right position using multi monitor system. upgraded TeraTerm Menu to 1.03.
- upgraded LogMeTT to 2.7.2

### 2005.10.7 (Ver 4.21)

- expanded scroll range width from 16bit to 32bit.
- added 'waitregex' macro command. This command enables the macro script to wait the specified keyword with regular expression.
- added the system variable 'matchstr' which will store the matched pattern with regular expression.
- added the sample TTL macro 'wait_regex.ttl'.
- added regular expression library 'Oniguruma' version information on TeraTerm version dialog.

### 2005.9.5 (Ver 4.20)

- upgraded TTSSH version supporting SSH2 to 2.17

### 2005.8.27 (Ver 4.19)

- Bug fix: division result is invalid in TeraTerm macro script. Special thanks to Takashi SHIRAI.
- changed not downing ttpmacro.exe process priority with logging
- upgraded LogMeTT to 2.6.1

### 2005.7.24 (Ver 4.18)

- added showing the line number and data of TTL file on macro dialog.
- Bug fix: DAKUTEN(the dot marks) might not be correctly shown in UTF-8 for Mac OS X.
- upgraded LogMeTT to 2.5.6

### 2005.5.29 (Ver 4.17)

- changed scroll out the current buffer when the cursor position is only located on left-upper screen at receiving <ESC>[J(Clear screen from cursor-position up to end).

### 2005.5.28 (Ver 4.16)

- added saving log type(plain text) information to teraterm.ini(LogTypePlainText).
- added CygTerm settings on Additional settings dialog.
- added CygTerm settings on Additional settings dialog.
- added support of selecting several pages(also expansion ans contraction of text area that has been selected). Start selected region is saved with mouse left click. End selected region is saved with Shift + mouse left click.
- added scroll out the current buffer when TeraTerm clear screen at receiving <ESC>[J.
- added the workaround of CPU time 100% using TeraTerm macro(insert 100msec sleep after send and sendln).

### 2005.4.24 (Ver 4.15)

- added the accelerator key(ALT+Enter) that maximizes TeraTerm window.
- added saving Eterm look-feel alphablend settings to teraterm.ini file.
- added changing Eterm look-feel alphablend on/off on Additional settings dialog.
- fixed the installer problem not copying font file on Windows98. Special thanks to Boris.
- added TeraTerm License file(license.txt).
- upgraded macro help file(English version). Special thanks to Boris.
- upgraded LogMeTT to 2.4.4

### 2005.4.9 (Ver 4.14)

- added click-able URL mechanism that mouse pointer overs on URL string. Special thanks to monkey magic. And also added URLColor, EnableClickableUrl entry in teraterm.ini file.
- added support of escape sequence(ESC[39m:foreground color reset, ESC[49m:background color reset). This support solves the problem that color can't be clear using w3m on screen(1) command. Special thanks to Iwamoto Kouichi.
- added mouse cursor dynamically changing on Additional settings.
- added support of click-able URL on TeraTerm version dialog.
- canceled the limitation that at "Duplicate session" on SSH2 connected communication, TeraTerm always try to connect the server with SSH2 protocol.
- added SSH auto-login with "Duplicate session".
- upgraded LogMeTT to 2.4.3

### 2005.3.31 (Ver 4.13)

- fixed TeraTerm version information can't be shown in version dialog at second later instance.
- added the configuration of disabling paste string by clicking mouse right button in teraterm.ini(DisablePasteMouseRButton) and Additional settings dialog.
- fixed the TeraTerm crashing problem when the sending file size exceeded 20MB with ZMODEM protocol. Special thanks to Thorsten Behrens.
- upgraded LogMeTT to 2.4.2

### 2005.3.13 (Ver 4.12)

- upgraded ttermpro.exe version information from 2.3 to 4.12.
- fixed the multi-byte problem that the cursor scrolls to upper direction when ZENKAKU(Japanese character) cross the end of line. Special thanks to Iwamoto Kouichi.
- added TeraTerm title multi-byte character converting EUC-JP to Shift_JIS(CP932).
- upgraded LogMeTT to 2.1.2

### 2005.2.22 (Ver 4.11)

- fixed the problem that log menu doesn't become gray on logging
- added Eterm look-feel alphablend. Special thanks to AKASI.
- added support of VisualStyle(WindowsXP)
- added new Title Format ID(13). i.e, <host/port> - <title> VT/TEK
- added the show of COM5 over when the caption was displayed
- added new logging type "plain text" on log saving dialog. If the option is enabled(default), TeraTerm doesn't include ASCII non-display characters in log file. Exceptionally the following characters(HT, CR, LF) include at any mode.
- added TTProxy(2004/1/22 version) supporting to TELNET/HTTP/SOCK proxy. Special thanks to YebisuyaHompo.
- added newly LogMeTT 2.02beta. Special thanks to Boris.
- deleted LogMeIn
- changed "Additional settings" dialog to tab control dialog
- changed the setting default file name of logging to "teraterm.log"

### 2005.1.30 (Ver 4.10)

- enabled maximum button
- deleted the accelerator key of TeraTerm Menu and LogMeIn
- added the setting default file name(log_YYYYMMDD_HHMMSS.txt) of logging
- added the Broadcast command menu under Control menu
- added the homepage URL at version dialog
- fixed the initial directory of "Save setup" dialog at reading teraterm.ini directory
- added "View Log" menu under File menu
- added "View Log Editor" text-box on "Additional settings" dialog
- added the "ViewlogEditor" entry at [Tera Term] section of teraterm.ini
- upgraded TTSSH version supporting SSH2 to 1.08
- upgraded TeraTerm Menu supporting SSH2 to 1.02.
  - added Kanji code(/KT=UTF8 /KR=UTF8) of default option
  - added specify of user parameter at SSH auto-login
  - deleted macro specification at SSH auto-login
  - added specify of private-key-file at SSH auto-login

### 2005.1.10 (Ver 2.3+UTF-8 2.09)

- fixed the bug of switching back to primary display when changing terminal size on multi display environment. Special thanks to Tsuruhiko Ando.

### 2005.1.6 (Ver 2.3+UTF-8 2.08)

- changed the logging dialog type from open-dialog to save-dialog
- fixed the initial directory of "Save setup" dialog at program directory
- upgraded TTSSH version supporting SSH2 to 1.07

### 2005.1.5 (Ver 2.3+UTF-8 2.07h)

- upgraded TTSSH version supporting SSH2 to 1.06

### 2004.12.27 (Ver 2.3+UTF-8 2.07g)

- upgraded TTSSH version supporting SSH2 to 1.05

### 2004.12.23 (Ver 2.3+UTF-8 2.07f)

- upgraded TTSSH version supporting SSH2 to 1.04

### 2004.12.18 (Ver 2.3+UTF-8 2.07e)

- upgraded TTSSH version supporting SSH2 to 1.03

### 2004.12.16 (Ver 2.3+UTF-8 2.07d)

- upgraded TTSSH version supporting SSH2 to 1.02

### 2004.12.15 (Ver 2.3+UTF-8 2.07c)

- fixed the attribute of font file in the installed directory
- added killing the process relation to TeraTerm at installation (using taskkill command)

### 2004.12.14 (Ver 2.3+UTF-8 2.07b)

- changed the initial value of scroll buffer size from 400000 to 20000 in the 'teraterm.ini' file.
- added changing the attribute of font file to ReadOnly.
- upgraded TeraTerm Menu supporting SSH2 to 1.01. Changed the initial folder path of ttermpro.exe to current directory.

### 2004.12.11 (Ver 2.3+UTF-8 2.07a)

- upgraded TTSSH version supporting SSH2 to 1.01

### 2004.12.8 (Ver 2.3+UTF-8 2.07)

- renamed "External setup" "Additional settings and removed the dialog to "Setup" menu
- added "Duplicate session" to "File" menu (add /DUPLICATE option)
- changed downing ttpmacro.exe process priority only with logging
- didn't include CR+LF in log file when multiple line has concatenated (as EnableContinuedLineCopy enabled)
- extended the max line of scroll buffer to 400000 line
- upgraded TTSSH version supporting SSH2 to 1.00(RTM)
- added LogMeIn 1.21. It is thankful to Boris Maisuradze.
- added TeraTerm Menu 0.94r2(+SSH2 support 1.00). It is thankful to Shinpei Hayakawa.
- in addition, fine bug fix

### 2004.11.6 (Ver 2.3+UTF-8 2.06)

- fixed drawing ruled line with DEC special font remains garbage graphics, moreover UTF-8 feature to display only Japanese characters. And also fixed BOLD style of font problem.
- TeraTerm second later instances can read configuration from teraterm.ini.
- added drag&drop directory path in teraterm from explorer.
- rewrote README(English). Special thanks to Boris Maisuradze for his cooperation.

### 2004.10.25 (Ver 2.3+UTF-8 2.05a)

- upgraded TTSSH version supporting SSH2 to 1.00alpha4

### 2004.10.11 (Ver 2.3+UTF-8 2.05)

- added MFC7.1 runtime library
- setup environmental variable 'TERATERM_EXTENSIONS' is now ignored, TTSSH is always loaded.
- fixed UTF-8 encoding of HANKAKU KANA.
- added /nossh option (fixed problem that doesn't start Cygterm with TTSSH section(Enabled=1) of teraterm.ini file)
- added SSH2 version TTSSH(1.00alpha2)

### 2004.9.29 (Ver 2.3+UTF-8 2.04a)

- changed patch to binary files for distribution
  I replied permission from the TeraTerm original author (Mr.Teranishi). I appreciate.

### 2004.9.5 (Ver 2.3+UTF-8 2.04)

- fixed running macro halt problem on logging
- added "External setup" dialog to "Edit" menu
- saved ANSI color setting to ini file

### 2004.8.6 (Ver 2.3+UTF-8 2.03)

- assigned the accelerator key to Cygwin connection menu to 'Alt + G'
- added show of the full path in logging dialog
- added support of users comments that can be included into log file
- replaced static link to dynamic load of SetLayeredWindowAttributes() API (for NT4.0)
- replaced WDiff with udm of difference making tool

### 2004.4.12 (Ver 2.3+UTF-8 2.02)

- added support of UTF-8 for Mac OS X(HFS+)
- added feature to display other than Japanese characters (locale and code-page have to be set up)
- added feature to input other than Japanese characters (link 'imm32.lib')
- removed BOM(Byte Order Mark) in receive mode
- In addition, fine bug fix

### 2004.3.19 (Ver 2.3+UTF-8 2.00a)

- fixed README file

### 2004.3.18 (Ver 2.3+UTF-8 2.00)

- changed original source to IPv6 version (thanks to Mr.J.Kato).
- added support of translucence window
- added support of Cygwin connection
- added support of selecting all buffer
- added support of different mouse cursor types and their configuration
- switched from WinSock1.1 to 2.2
- In addition, fine bug fix

### 2004.3.13 (Ver 2.3+UTF-8 1.02)

- reverted host name max-length to 80.
- added support of UTF-8 for sending

### 2004.3.9 (Ver 2.3+UTF-8 1.01a)

- fixed README file
- checked that SSH is operational with TTSSH 1.5.4 + IPv6 0.81

### 2004.3.6 (Ver 2.3+UTF-8 1.01)

- added support of wheel mouse button
- added "UTF8" value for /KR option of command line
- powered up UTF-8 conversion (addition referrer table)
- extended host name max-length from 80 to 1024

### 2004.3.2 (Ver 2.3+UTF-8 1.00)

- first release

## Tera Term Pro (Original Version)

### 1998.3.10 (Ver 2.3 & 1.4)

- Serial ports larger than COM4
- Baud rate of 14400
- User shortcut keys "EditCLS", "EditCLB", "ControlOpenTEK" and "ControlCloseTEK".
- Macro commands "clearscreen", "code2str", "enablekeyb", "filemarkptr", "fileseekback", "filestrseek2", "findclose", "findfirst", "findnext", "getdir", "kmtfinish", "kmtget", "makepath", "sendkcode", "setdir", "setexitcode", "str2code" and "testlink".
- Macro operator "%".
- Macro: a comment can be placed in any line.
- Pass-through printing directly to a port.
- Special options in the setup file "AutoFileRename", "BackWrap", "Beep", "EnableStatusLine", "MaxComPort", "PassThruDelay", "PassThruPort", "PrnConvFF", "RussPrint" and "TitleFormat".
- New [Setup] TCP/IP dialog box.
- History list of hosts.
- New Russian character sets (CP 866,and ISO 8859-5).
- New icons.
- Selecting text in a rectangular region.
- Executing menu commands by user defined keys.
- Tera Term extension interface.

### 1997.7.2 (Ver 2.2)

- Bug fixes.

### 1997.6.30 (Ver 2.1)

- Installer and uninstaller
- 32-bit versions of TTPMACRO.EXE and KEYCODE.EXE
- Russian mode
- "[Edit] Copy table", "[Setup] Load key map" and "[Window]" commands
- Status line of the VT terminal
- Pass-through printing
- ANSI full color
- New command-line options (/I, /L=<log file>, /LA=<language>, /M=<macro file> and /V)
- Port number just after a host name in the command line (such as "myhost.mydomain 23")
- New read-only options in the Tera Term setup file
- New items in the keyboard setup file
- Macro execution by pressing a user defined key
- New command-line options of TTPMACRO (/I and /V)
- New macro commands

### 1996.6.7 (Ver 2.0)

- 32-bit version.

### 1996.6.7 (Ver 1.3)

- Telnet break signal.
- new item in the keyboard setup file (SendBreak=).
- host name with a port number in the command line (such as "myhost.mydomain:23").
- comment in the command line.
- new [Setup] Serial port dialog box.
- Alt+[mouse right button].

### 1995.12.18 (Ver 1.2)

- English mode.
- Quick-VAN protocols.
- added a lot of macro commands(control structure, subroutine, include file)
- changed the mouse operation.
- scroll buffer on/off
- added the [Shortcut keys] section in the keyboard configuration file.
- File transfer directory can be saved.
- added the command line option(/FD=, /H).
- added the read-only options (QVLog=, QVWinSize=, ZmodemAuto, BPAuto, VTFontSpace=, HideTitle=).

### 1995.7.22 (Ver 1.1)

- added a lot of macro commands(file operation, string operation)
- Meta Key
- added the read-only option (ConfirmDisconnect=).
- Both the log and the file send, and both the log and the protocol transfer can be executed simultaneously.

### 1995.7.3 (Ver 1.0)

- ZMODEM and B-Plus protocols.
- DEC special character set.
- added bold font supporting.
- added the exit confirmation while TELNET is connecting.
- Telnet AYT
- changed the color setting of the bold/blink attribute.
- added the "Terminal size = window size" option.
- added the command line option(/W=, /X=, /Y=, /KR=, /KT=).
- added the read-only options(XmodemLog=, BPLog=, ZmodemLog=, ZmodemEscCtl=, ZmodemDataLen=, ZmodemWinSize=) in the teraterm.ini file.

### 1995.4.25 (Ver 0.9)

- XMODEM protocol.
- added the 3D dialog box (CTL3D.DLL supporting)
- added the XTERM sequence (title changing)
- added support for sending a text file by using file manager drag&drop.
- Pop-up menu
- added the bold/blink color setting (bold font was removed).
- added the ANSI escape sequence (color setting, cursor save and restore)
- changed the log&file send (binary, append, pause/start).
- added the log file replay feature.
- A filename of the keyboard configuration can be specified.
- added support for the macro command.
- added the printer font setting(read-only option).
- added the C1 control character setting(read only option).
- telnet binary option (read-only option).

### 1995.2.17 (Ver 0.8)

- Macro language "Tera Term Language".

### 1995.1.27 (Ver 0.7)

- Local echo
- VT<->TEK auto change enable/disable
- added the TCP port# setting.
- telnet enable/disable
- The TEK and file transfer function is changed to DLL module.
- TEK color emulation
- TEK line style
- F10 key
- changed the command line option.

### 1994.10.31 (Ver 0.6)

- User keys.
- added the key configuration of the VT200 escape sequence.
- 'Help' button on dialog box
- read-only options.

### 1994.10.3 (Ver 0.5)

- Kermit protocol.
- file transfer without protocol.
- Kanji (JIS).
- The window size and terminal size are separated.
- added support for the IME control.
- added support for the configuration setting.
- dynamic link libraries
- added the XWINDOW-style copy&paste.
- transmit delay (serial port)
- answerback
- host list
- The ".tt" file was removed.
- changed the command line option.

### 1994.5.16 (Ver 0.4)

- Keyboard setup.
- added support for the TEK copy/paste.
- added support for the printer function (VT, TEK).
- added support for the color setting (VT, TEK).
- added the size setting of the VT screen.
- telnet NAW option
- added support for a part of the VT200/300 function.
- Clear page.
- Reset terminal.
- Send break.
- Reset port.

### 1994.3.29 (Ver 0.3)

- Telnet option negotiation.
- TEK GIN
- added support for the window caption setting.
- added support for the font setting.
- added support for the code-changed setting.
- added support for the BS key-changed setting.
- File Open/Save
- New session
- Clear buffer (VT)
- Clear screen (TEK)
- ".tt" file.

### 1994.X.X (Ver 0.2)

- Port setup dialog box.
- help file.

### 1994.X.X (Ver 0.1)

- TCP/IP connection (Winsock).

### 1994.2.24 (Ver 0.0)

- Serial port connection.
- Kanji (SJIS & EUC).
- VT100 and TEK4010.

## TTSSH

### 2023.10.15 (Ver 3.0)

- Changes
  - added support for SSH2 host key algorithms: rsa-sha2-256, rsa-sha2-512 (RSA key with SHA-2 signature)
  - added support for SSH2 public key authentication methods: rsa-sha2-256, rsa-sha2-512 (RSA key with SHA-2 signature)
  - disabled SSH2 KEX algorithm by default for RFC 9142 recommendations: diffie-hellman-group1-sha1, diffie-hellman-group-exchange-sha1
  - changed default SSH heartbeat (keep-alive) interval to 300 seconds.
  - now TTSSH icon is used when the notify caused by TTSSH.
  - changed the default key type to ED25519 on Key Generator dialog.
- Bug fixes
  - when SSH2 dynamic port forwarding is used, an application fault occurs.
  - when receiving SCP with fast network, received data is not written until finish receiving and memory usage increases, or no response.
  - when receiving SSH_MSG_CHANNEL_EXTENDED_DATA on SCP channel, there is a possibility that cause problem because it is processed as normal SCP data.
    - a message from remote is shown by balloon notify.
  - stop discarding SSH_MSG_CHANNEL_DATA send that occurs while key re-exchange, send them after finish key exchange.
  - when Authentication Setup dialog is opened, username setting value is "Use default username" (DefaultUserType=1), nevertheless "Do not enter username" is selected.
- Misc
  - changed cryptography library from OpenSSL to LibreSSL 3.7.3.
  - upgraded zlib to 1.3.

### 2021.6.5 (Ver 2.92)

- Changes
  - added chacha20-poly1305@openssh.com symmetric key cipher algorithm for SSH2 protocol.
  - added support for the PuTTY private key file format version 3 (PPK3).
- Bug fixes
  - When the Virtual Store is enabled on Windows Vista or later and the Host key rotation is enabled, the original host key is accidentally deleted from known_hosts file.
  - When the Virtual Store is enabled on Windows Vista or later and the host key type is same but key contents is different, the host key can not be deleted from known_hosts file.
  - When many files are sent in a batch by using D&D's SCP sending, an error occurs.
  - When you resize the VT window or send a break signal immediately after user authentication was completed, connection is closed by server.
  - When system memory is insufficient, invalid signature may be used as correct one well with signature verification by the host key at the time of key exchange.
  - A part of control is always enabled on SSH authentication dialog.
- Misc
  - upgraded OpenSSL from 1.1.1d to 1.1.1k.

### 2019.12.7 (Ver 2.91)

- Changes
  - Changed of indication from "Protocol" to "IP version" and from "UNSPEC" to "AUTO" on New connection dialog.
  - The display timing of the user authentication dialog is changed to display after the known_hosts dialog.
  - The LogLevel entry is added on the Setup dialog.
  - The help button are added on the Setup dialog, Authentication Setup dialog, Forwarding dialog and Key Generator dialog.
  - When the network is disconnected from SSH server side, the known_hosts and user authentication dialog are automatically closed while the dialog is shown.
  - Changed the error message when unable to open local file.
- Bug fixes
  - The same messages may be included on MessageBox displaying.
  - When the network is disconnected from SSH server side, an application fault may be occurred while known_hosts dialog is shown.
  - SSH1: The /nosecuritywarning option does not work well.
  - The problem is improved in the user authentication dialog that the delay occurs when the focus is moved from the user name to passphrase by using TAB key after entering the user name.
  - When the user name is left blank in the user authentication dialog, the focus may not be moved from the user name to the pull-down menu on the right side with TAB key.
  - Fixed a port forwarding issue that closes the client connection before completing all data transmission.
  - Incorrect process ID is recorded in TTSSH.LOG before connecting.
  - Authentication banner cannot display correctly when banner string contains character other than US-ASCII.
- Misc
  - upgraded OpenSSL from 1.0.2s to 1.1.1d.

### 2019.08.31 (Ver 2.90)

- Bug fixes
  - SSH2: When SSH communication is slow by using port forwarding, an application fault is occurred due to increase memory consumption.
  - SSH2: When SCP transfer dialog is closed, the directory of file transfer setting and the SCP destination path setting may not be updated.
  - SSH2: When SCP transfer is started on Windows 95/98/Me, an application fault occurs.
  - SSH1: When the destination port number is other than 22, an application fault may be occurred after the host key is newly written to known_hosts file.
  - SSH1: The rhosts authentication could not be performed at all.

### 2019.06.15 (Ver 2.89)

- Changes
  - Windows logon user name can be configured as the default user name.
    - added the DefaultUserType entry in the teraterm.ini file. The default is 1(Using a specified default user name).
  - added a selector whether to use control characters in the Inputing Password and Passphrase of the authentication dialog.
- Bug fixes
  - garbage data is added to the CipherOrder and MacOrder settings when saving settings.
  - when echo flag is 1 in the server's authentication information message, password string is masked on the keyboard-interactive authentication dialog.
- Misc
  - upgraded OpenSSL to 1.0.2s.

### 2019.02.28 (Ver 2.88)

- Changes
  - added /ssh-N commandline option to disable a shell session when starting a connection.
  - Default state of bcrypt KDF checkbox on SSH Key generator dialog is changed to on.
- Bug fixes
  - Can't change password on SSH Change Password dialog when old password is empty string.
- Misc
  - upgraded OpenSSL to 1.0.2r.

### 2018.11.30 (Ver 2.87)

- Misc
  - upgraded OpenSSL to 1.0.2q.

### 2018.08.31 (Ver 2.86)

- Bug fixes
  - SSH Forwarding dialog shows incorrect setting after the connection is closed.
- Misc
  - upgraded OpenSSL to 1.0.2p.

### 2018.05.31 (Ver 2.85)

- Changes
  - in /auth= commandline option, accept keyboard-interactive keyword.
- Bug fixes
  - Can't open normal ssh (shell) session after using ssh subsystem.
- Misc
  - upgraded OpenSSL to 1.0.2o.

### 2018.02.28 (Ver 2.84)

- Changes
  - added support for SSH_MSG_USERAUTH_BANNER SSH message.
    - added the AuthBanner entry in the teraterm.ini file. The default is 1(display to VT window).
  - The minimum group size of the Diffie-Hellman group exchange key exchange method is increased to 2048. (RFC 8270)
    - To change to the previous behavior, set the GexMinimalGroupSize entry in teraterm.ini file to 1024.
- Bug fixes
  - Application fault is occurred if server proposes a very long string in the algorithm negotiation.
  - When using aes128-gcm@openssh.com or aes256-gcm@openssh.com as symmetric cipher algorithm, connection is terminated if MAC algorithm cannot negotiate.
  - The [SSH SCP] entry of [File] menu can not be disabled on serial connection.
  - When using aes128-gcm@openssh.com or aes256-gcm@openssh.com as symmetric cipher algorithm, un-used MAC algorithm is displayed on "About TTSSH" dialog.
  - The fingerprint of server host key on "About TTSSH" dialog may display unused key by current connection, which is different key method and is of same server.
- Misc
  - upgraded OpenSSL to 1.0.2n.

### 2017.11.30 (Ver 2.83)

- Changes
  - added support for SSH2 symmetric key cipher algorithms:
    - aes128-gcm@openssh.com
    - aes256-gcm@openssh.com
  - added support for SSH2 MAC algorithms:
    - hmac-sha1-etm@openssh.com
    - hmac-sha2-256-etm@openssh.com
    - hmac-sha2-512-etm@openssh.com
    - hmac-ripemd160-etm@openssh.com
    - hmac-md5-etm@openssh.com
    - hmac-sha1-96-etm@openssh.com
    - hmac-md5-96-etm@openssh.com
  - The terminal speed notifies to the server can be changed by setting.
    - added the TerminalSpeed entry in the teraterm.ini file. The default is 38400.
    - The default value of the terminal speed notifies to the server is changed to 38400 bps.
- Misc
  - upgraded OpenSSL to 1.0.2m.

### 2017.08.31 (Ver 2.82)

- Changes
  - added support for the PuTTY format ECDSA private key and Ed25519 private key for SSH2 public key authentication.
  - added support for the SECSH(ssh.com) format ECDSA private key for SSH2 public key authentication.
  - added support for dynamic port forwarding (SOCKS Proxy).
  - Output format of some debug log is changed.
- Bug fixes
  - The remote-to-local port forwarding which added after connecting to the server does not be enabled on SSH2 connection.
  - When the terminal size is changed, right terminal size (pixel count) is notified to server on SSH1 connection.
  - The SSH_MSG_UNIMPLEMENTED message is not handled correctly.
  - Garbage is output in the debug log.
- Misc
  - upgraded OpenSSL to 1.0.2l.
  - upgraded PuTTY to 0.70.

### 2017.05.31 (Ver 2.81)

- Changes
  - added support for changing the user password when using the password authentication.
  - added support for executing the specified subsystem instead of the shell on connection.
    - added the /ssh-subsystem option at the command line.
  - added the notification feature when remote host uses forwarded agent. (Windows Me or 2000 or later)
- Bug fixes
  - When agent forwarding is enabled, an application fault is occurred after the remote host sends big packet request.
- Misc
  - upgraded PuTTY to 0.69.

### 2017.02.28 (Ver 2.80)

- Bug fixes
  - When SCP receiving is failed, a local file is removed.
- Misc
  - upgraded OpenSSL to 1.0.2k
  - upgraded zlib to 1.2.11

### 2016.11.30 (Ver 2.79)

- Bug fixes
  - When an Order(CipherOrder, KexOrder, HostKeyOrder, MacOrder, CompOrder) is read from the teraterm.ini file, memory corruption will be occurred.
  - Tera Term(TTSSH) may hang up while a file is receiving by using SCP.
- Misc
  - upgraded OpenSSL to 1.0.2j

### 2016.08.31 (Ver 2.78)

- Changes
  - When the filename includes invalid character by SCP receiving, the character is be replaced to '_'.
  - The default value of ScpSendDir entry is changed from "~/" to ""(empty string).
  - Strictly TTSSH command line can be checked. When a part of options(i.e. /ssh-A) is added with unnecessary character(i.e. /ssh-Axx), the string can not be recognized as an option.

### 2016.05.31 (Ver 2.77)

- Changes
  - updated to new TTSSH icon file(ttsecure.ico). Special thanks to Tatsu Sakamoto.
- Bug fixes
  - The key length of blowfish-ctr symmetric key cipher is changed to 256 bits in accordance with RFC 4344.
  - When all key exchange method are enabled, the latest method can not be used.
  - When the X11 forwarding starts, the connection error will be occurred with error code(WSANO_RECOVERY: 11003).
- Misc
  - upgraded OpenSSL to 1.0.2h
  - upgraded PuTTY to 0.67

### 2016.03.05 (Ver 2.76)

- Changes
  - added support for SSH2 key exchange methods: diffie-hellman-group14-sha256, diffie-hellman-group16-sha512, diffie-hellman-group18-sha512
  - The arc4random() function is changed from OpenSSL'RC4 to ChaCha20 base.
- Misc
  - upgraded OpenSSL to 1.0.2g

### 2015.12.01 (Ver 2.75)

- Changes
  - When the fingerprint of the host key is shown on the known_hosts and the "About TTSSH" dialog, the hash algorithm can be not only MD5, but SHA256.
  - Added support for the ED25519 key by using the host key verifying(SSHFP) of DNS.
  - The key exchange, host key, cipher, MAC and compression method which are not shown in the teraterm.ini file is changed for inserting position in the following:
    - Enabled method by default ... The method is inserted at the end of using methods.
    - Disabled method by default ... The method is inserted at the end of not using methods.
  - The command line option can be quoted from an offset when the '"' is used.
- Bug fixes
  - The OpenSSH can not read the SSH private key file of the KDF format.
  - When the About TTSSH dialog is shown after the host key is replaced and is rotated, an application fault will be occurred.
- Misc
  - upgraded PuTTY to 0.66

### 2015.09.01 (Ver 2.74)

- Changes
  - added the "Hostkey rotation" entry on the "TTSSH: Setup" dialog box.
  - The host key rotation(derived from OpenSSH 6.8 or later) dialog is changed from MessageBox to DialogBox(same as Security Warning).
  - Minimal size of an acceptable group in a request of Diffie-Hellman group exchange can be specified.
    - added the GexMinimalGroupSize entry in the teraterm.ini file. The default value is 0.
  - The Arcfour series cipher algorithm is disabled by default in the Preferred cipher order.
  - An error number can be included in the error message regarding the X11 port-forwarding failure.
- Bug fixes
  - added a workaround because the Tera Term 4.87(TTSSH 2.73) can not connect to a part of Cisco devices.
  - When the known_hosts file is updated by the host key rotation, an application fault will be occurred after the fingerprint display of the "About TTSSH" dialog.
- Misc
  - upgraded OpenSSL to 1.0.2d
  - upgraded PuTTY to 0.65

### 2015.05.31 (Ver 2.73)

- Changes
  - added support for the host key rotation(derived from OpenSSH 6.8).
    - added the UpdateHostkeys entry regarding the server public key updating in the teraterm.ini file. The default value is disabled.
  - The /f=, /ssh-f= and /ssh-consume= command option can be read earlier than other option.
  - The group size that the key exchanging of the Diffie-Hellman group exchange method requests is increased to NIST SP 800-57 standards.
- Bug fixes
  - A user can not connect to the OpenSSH 6.8 server.
  - When the 0(disabled line) is located at the front end of any algorithm(CipherOrder, KexOrder, HostKeyOrder, MacOrder and CompOrder), an application fault is occurred.
  - A command line option after ; can not be recognized as remark.
  - When the filename and password value contains a semicolon(;) by using the session duplication, the semicolon can not be quoted.
- Misc
  - upgraded PuTTY to 0.64
  - upgraded OpenSSL to 1.0.2a

### 2015.02.28 (Ver 2.72)

- Changes
  - When the private key is saved on the SSH key generator dialog, the round number of the bcrypt KDF can be specified.
  - added support for specifying the X11 destination display with the /ssh-X command line option.
    - added the X11Display entry in the teraterm.ini file. The default value is empty.
- Bug fixes
  - When the private key of the KDF format does not include the passphrase, the public key authentication can not work well.
  - When the private key of the KDF format without passphrase is recorded, the key file is mistakenly encrypted.
- Misc
  - upgraded OpenSSL to 1.0.2

### 2014.11.30 (Ver 2.71)

- Changes
  - Changed the SSH disconnection sequence.
- Bug fixes
  - When the SSH host key is replaced to another key, an application fault occurs.
- Misc
  - upgraded OpenSSL to 1.0.1j

### 2014.08.31 (Ver 2.70)

- Changes
  - When a file is received by using SCP protocol, the file time-stamp is updated.
  - added the DisablePopupMessage entry to disable the error pop-up message box in the teraterm.ini file.
- Bug fixes
  - When the SCP receiving procedure is canceled, Tera Term(TTSSH) will stall.
  - When the filename contains the space and bracket characters, the SCP receiving procedure is failed.
  - The SCP procedure can not work well onto the Windows Task Scheduler.
- Misc
  - upgraded OpenSSL to 1.0.1i

### 2014.06.01 (Ver 2.69)

- Changes
  - added support for the key exchange of Curve25519 elliptic curve DH(Diffie Hellman) algorithm.
    - Key Generator supports the ED25519 authentication key.
    - Key Generator supports the bcrypt KDF format of the RSA/DSA/ECDSA private key.
    - added the ED25519 into the Host Key algorithm, and then changed the HostKeyOrder entry in the teraterm.ini file.
  - added the host key's fingerprint and the random art into the "About TTSSH" dialog.
  - TTY option ONLCR can be sent to the remote server.
- Bug fixes
  - The unencrypted PKCS #8 formatted key can not be read.
  - When the remote host disconnects while the authentication dialog is shown, an application fault occurs.
- Misc
  - upgraded OpenSSL to 1.0.1g

### 2014.02.28 (Ver 2.68)

- Bug fixes
  - The SCP transfer is always aborted when the Tera Term window is minimized.
- Misc
  - upgraded OpenSSL to 1.0.1f
  - Changed the `T' character of TTSSH icon to blue color.

### 2013.11.30 (Ver 2.67)

- Bug fixes
  - When the SSH2 port-forwarding is repeatedly executed, new port-forwarding can not work well.

### 2013.09.01 (Ver 2.66)

- Changes
  - SSH SCP: When the scp received directory is changed, the FileDir entry in the teraterm.ini can be updated.
- Misc
  - upgraded PuTTY to 0.63

### 2013.05.31 (Ver 2.65)

- Changes
  - The SSH icon can be specified.
    - added the SSHIcon entry in the teraterm.ini file. The default value is "Default".
    - added the /ssh-icon option at the command line.
- Bug fixes
  - The PKCS #8 formatted key can not be read.
  - When the "stty stop undef" is defined in the ~/.bashrc, an application fault will be occurred by using SCP sending.
- Misc
  - upgraded zlib to 1.2.8

### 2013.02.28 (Ver 2.64)

- Changes
  - The encryption algorithm is changed from 3DES to AES128 when the SSH2 private key is saved with the passphrase.
- Misc
  - upgraded OpenSSL to 1.0.1e

### 2012.12.02 (Ver 2.63)

- Changes
  - Removed the hmac-sha2-256-96 and hmac-sha2-512-96 of SSH2 HMAC algorithm because these protocol are obsolete. Refer to the RFC6668(OpenSSH 6.1).
  - added support for the PuTTY format and SECSH(ssh.com) format of the private key for SSH2 public key authentication.
  - added some service names of the port number at the SSH Forwarding dialog.
  - The length of the DSA key on the SSH Keygenerator is fixed at 1024 bit because the SSH protocol will support only the 1024 bit officially.
  - changed the TTSSH icon to the green color.
- Bug fixes
  - SCP sending will be failed for SSH server which the window size is small(Dropbear).
  - The SSH data will be corrupted by SSH2 delay re-transmit bug.
  - When the Java Web Start is used with X11 forwarding, Tera Term and Xming will stall.
  - When the X11 forwarding starts, the connection error will be occurred.

### 2012.08.31 (Ver 2.62)

- Changes
  - When the host number is discontinuous value, Tera Term can read the [Hosts] section in the teraterm.ini file.

### 2012.05.31 (Ver 2.61)

- Changes
  - The comment of the public key can be specified on the SSH Key Generator dialog.
  - The destination path can be specified on the SSH SCP dialog.
- Bug fixes
  - added proceeding the debug message(SSH_MSG_DEBUG) from the remote host.
- Misc
  - upgraded OpenSSL to 1.0.1c
  - upgraded zlib to 1.2.7

### 2012.02.29 (Ver 2.60)

- Misc
  - upgraded PuTTY to 0.62
  - upgraded OpenSSL to 1.0.0g
  - upgraded zlib to 1.2.6

### 2011.12.04 (Ver 2.59)

- Changes
  - When the SSH version of the TTSSH does not match the server protocol version, a user can not connect.
  - The control characters(^A-^_) can be input as the password string on the key generator dialog.
  - added the SSHFP RR on the Security Warning dialog.
    - added the "Verify hostkey fingerprint by DNS" check-box on the "TTSSH: Setup" dialog box.
- Bug fixes
  - When the server protocol is 1.99, Tera Term will connect with the SSH2 protocol by using the SSH1 specified protocol.
  - When the transferring display number is an integer other than zero, the X11 forwarding does not work well.
  - When the user authentication is failure, the user name of the authentication dialog will show the default user name instead of the user input name.
  - When the SSHFP verification is enabled and the SSHFP RR does not query, the application fault will occur.
- Misc
  - upgraded OpenSSL to 1.0.0e

### 2011.8.31 (Ver 2.58)

- Changes
  - added Camellia128-CBC, Camellia128-CTR, Camellia192-CBC, Camellia192-CTR, Camellia256-CBC, Camellia256-CTR symmetric key cipher algorithm for SSH2 protocol.
  - added support for SSH2 MAC algorithms: hmac-sha2-256, hmac-sha2-256-96, hmac-sha2-512, hmac-sha2-512-96
  - added the PuTTY version on the "About TTSSH" dialog.
  - removed the random initialization because it takes a long time to connect.
  - The time-stamp of the log file is recorded on the millisecond time scale.
- Bug fixes
  - When the IPv4 fall-back is occurred, the SSH connection may fail.
  - When the window size change is notified, the right window size(pixel) can be reported.
- Misc
  - upgraded PuTTY to 0.61

### 2011.6.26 (Ver 2.57)

- Changes
  - When the ECDSA key is selected on the SSH key generator dialog, the input box of the key bits is disabled.
  - Some kind of the KEX, host key, MAC and compression algorithm order can be specified in the teraterm.ini file. These entries can be selected on the setup dialog.
    - KexOrder=56743210
    - HostKeyOrder=456230
    - MacOrder=120
    - CompOrder=3210
  - added support for SSH2 MAC algorithms: hmac-sha1-96, hmac-md5-96, hmac-ripemd160@openssh.com
  - added the elapsed time and the transmit speed on the SCP dialog.
  - disabled the SSH SCP menu by not using the SSH connection.
- Bug fixes
  - Tera Term can not connect to the OpenSSH 5.7 later server by using SSH1 protocol.
  - SSH_MSG_CHANNEL_EXTENDED_DATA(SSH2) packet can not be worked well.
  - When SSH2 channel does not be opened, the application fault will be occurred.
  - When SCP is multiply executed, the procedure will not be worked well.
  - When a file is sending by using SCP and with the packet compression, the application fault will be occurred.

### 2011.3.5 (Ver 2.56)

- Changes
  - added support for confirming agent-forwarding request.
  - added support for SSH2 key exchange methods: diffie-hellman-group-exchange-sha256, ecdh-sha2-nistp256, ecdh-sha2-nistp384, ecdh-sha2-nistp521
  - added support for SSH2 host key algorithms: ecdsa-sha2-nistp256, ecdsa-sha2-nistp384, ecdsa-sha2-nistp521
  - added support for SSH2 public key authentication methods: ecdsa-sha2-nistp256, ecdsa-sha2-nistp384, ecdsa-sha2-nistp521
  - When the host key differs from the key included in the ssh_known_hosts file, Tera Term confirms whether a user adds the key instead of replacing.
- Bug fixes
  - The 2GB over file can not send by using the SCP protocol.
- Misc
  - upgraded OpenSSL to 1.0.0d

### 2010.12.7 (Ver 2.55)

- Changes
  - added support for sending a BREAK signal to the remote host on Control menu - Send break(only useful for SSH2). Also, the sendbreak macro can support it.
  - added support for changing the user password by using the keyboard-interactive method.
  - added command line options for control compression /ssh-C,/ssh-C=,/ssh-c.
- Bug fixes
  - An application fault may occur when the remote system does not return the SSH2 authentication method.
- Misc
  - upgraded OpenSSL to 1.0.0b

### 2010.8.31 (Ver 2.54)

- Bug fixes
  - SSH cryptographic algorithm 'aes128-cbc' can not be available.
- Misc
  - upgraded OpenSSL to 1.0.0a

### 2010.5.31 (Ver 2.53)

- Changes
  - Specifying the listen address in the port forwarding.
    - removed the configuration that accepts the connection from other hosts.
    - changed command line options.
    - changed SSH Port Forwarding dialog.
  - added 3DES-CTR, Blowfish-CTR and CAST128-CTR symmetric key cipher algorithm for SSH2 protocol.
    - added "C", "D" and "E" to CipherOrder entry in teraterm.ini file.
- Misc
  - upgraded OpenSSL to 1.0.0
  - upgraded zlib to 1.2.5

### 2009.11.10 (Ver 2.52)

- Changes
  - added the "/nosecuritywarning" option. Basically, do not use this option.
- Bug fixes
  - fixed the problem that the settings of TCPLocalEcho/TCPCRSend are not used after SSH connection was closed.

### 2009.7.5 (Ver 2.51)

- Changes
  - added a user can select a folder receiving a file on the SCP dialog.
  - added a dialog that confirms overwriting a file received via SCP.
  - use the default user name when the user name is not specified in autologin mode.
  - added a check box in the SSH Setup dialog box to configure the user password remembering in memory.
  - changed the command line specification for the space character
    - The specification replacing from the space character to the @ one was abolished.
    - A user can specify the "" characters instead of the " character.
- Bug fixes
  - Some Japanese characters can not use in the host name.
  - TTSSH does not work when the command line option(/FD=, /K=, /M=, /L=, /R=, /W=) includes the space character.
  - The crypt algorithm negotiation would be failure when the SSH2 key exchanges.
  - SCP transfer does not halt when the SCP window is minimized.
- Misc
  - upgraded OpenSSL to 0.9.8k

### 2009.3.22 (Ver 2.50)

- Changes
  - Changes ssh:// URL handling.
    - When a port number is not specified in the URL string, 22 port will be mandatory specified.
    - The percent-encoded user name and password are decoded.
  - added the `user@host' format in the host name of "New Connection" dialog and the command line option.
  - added a keyboard shortcut(&H) on SSH SCP menu.
  - added a SSH key bits edit-box on SSH KeyGenerator dialog.
  - added the progress status while a SSH key is generating.
  - Windows events while generating a SSH key on the SSH KeyGenerator dialog are discarded.
- Bug fixes
  - When a user does the SCP action twice, TeraTerm will be shut down after receiving SSH2_MSG_CHANNEL_FAILURE.
  - Application fault could occur when the generated key is saved with SSH key generator dialog.
  - When TTSSH about dialog is shown, the application fault occurs on Windows 95.
  - When a user switches the SSH authentication dialog from the host key confirmation dialog, a authentication method is overwritten by the default method value.
- Misc
  - upgraded OpenSSL to 0.9.8j

### 2008.12.16 (Ver 2.49)

- Changes
  - added AES128-CTR, AES192-CTR, AES256-CTR, Arcfour, Arcfour128, Arcfour256 and CAST128-CBC symmetric key cipher algorithm for SSH2 protocol. Security fix: CPNI-957037.
    - added "<", "=", ">", "?", "@", "A" and "B" to CipherOrder entry in teraterm.ini file.
  - added support for agent forwarding.
    - added the check box on SSH Setup dialog.
    - added the check box on SSH Authentication dialog.
    - added //ssh-A and /ssh-a command line option.
- Bug fixes
  - Bug fix: The general protection fault would occur on SSH1 connection. This bus was introduced in 2.48.
  - Bug fix: When the CheckAuthListFirst is enabled on SSH2 connection, TeraTerm disconnects after pushing the OK button of the dialog before the valid authentication method receives.
  - Bug fix: X11 forwarding does not work when DISPLAY environment variable configures.
  - Bug fix: History check-box has not been enable or disabled on a new connection.
  - Bug fix: A file with the SCP protocol could not send the remote host when the file name includes the space character.

### 2008.9.23 (Ver 2.48)

- added support for VisualHostKey feature with OpenSSH 5.1.
- added a `200' number to LogLevel entry in teraterm.ini file. This logging level enables a user to capture the SSH RAW packet data in a local file.
- Changed the error message of SSH2 RSA connection when the host key length is too short.
- Bug fix: TeraTerm would stall when a existing host key replaces on Windows Vista.
- upgraded OpenSSL to 0.9.8i

### 2008.6.25 (Ver 2.47)

- added the destination address of a received file on SSH SCP dialog.
- added support for port number of ssh_known_hosts file.
- updated to new TTSSH icon file(ttsecure.ico). Special thanks to Tatsu Sakamoto.
- Bug fix: memory leak problem
- Bug fix: The sending file with SCP could be locked.
- upgraded OpenSSL to 0.9.8h

### 2008.2.29 (Ver 2.46)

- added silently ignoring the Protocol Version Exchange line before sending the version string. (RFC4253 compliance)
- added the user interface for receiving a file on SSH SCP dialog.
  - The source address is fixed in the 'current directory for file transfers'.
  - Directly input the receiving file name
- added support for the public key authentication with Pageant(an SSH authentication agent for PuTTY, PSCP and Plink).
  - added "pageant" value to "/auth" command line switch.
- deleted a workaround for application fault when pressing ESC key at "SECURITY WARNING" dialog.

### 2008.1.15 (Ver 2.45)

- added support for sending a local file with SSH2 SCP(Secure Copy Protocol). Also, added SSH SCP menu under file menu.
  - The destination address is fixed in the home directory.
  - Not supporting for receive a file.
  - Only support for SSH2 protocol.
  - Not supporting for SFTP(SSH File Transfer Protocol).
- Bug fix: TCP disconnection was mis-detected in the packet sending. This bug was introduced in in TTSSH 1.01 because SSH heartbeat thread was not thread-safe.
- Bug fix: SSH is disabled when "/ssh1" or "/ssh2" is included in host name on New Connection dialog.
- Bug fix: Twice sending SSH2_MSG_SERVICE_REQUEST packet when the user default is not specified and the user authentication method is challenge, /ask4passwd is specified at command line parameter.
- Bug fix: TIS authentication dialog would not appear when CheckAuthListFirst entry is off and the user authentication method is challenge, /ask4passwd is specified at command line parameter.
- Bug fix: The user authentication would not work after OK button is pushed when CheckAuthListFirst entry is on and the user input box does not focus.

### 2007.12.4 (Ver 2.44)

- added AES192, AES256 and Blowfish symmetric key cipher algorithm for SSH2 protocol.
  - added "9", ":" and ";" to CipherOrder entry in teraterm.ini file.
- added support for SSH2 delay re-transmit packet when remote_window is not available by using port-forwarding(local-to-remote). X11 applications such as emacs and xterm would not work fine by using Xming server.
- Modified the feature to invalidate unsupported authentication method.
  - The default value of "CheckAuthListFirst" is changed to Off.
  - Added the feature to configure "CheckAuthListFirst" from a check-box in "SSH Authentication" dialog.
- Modified the feature in SSH forwarding connection from local to accept connection request from any host other than local host.
  - Added the feature to configure it from a check-box in "SSH Forwarding" dialog.
  - Added the feature to configure it as a command line option of "/ssh-acceptall".
  - Modified to enable it for each forwarding setup from "SSH Forwarding" dialog.
- Changed for " /ssh", " /nossh", " /telnet" specified as Host in "New connection" dialog to be given priority over "validate/invalidate" of SSH by radio button.
- Bug fix: TTSSH crashes when all server supports encryption algorithm that is not supported by TTSSH.
- Bug fix: SSH2 packet was occurred as "Bad packet length". This bug was introduced in TTSSH 2.42.
  - Bug fix: TCP disconnection was mis-detected in the packet sending.
- Bug fix: A big size packet could not send to the client application by using SSH2 port-forwarding(local-to-remote). This is TTSSH original bug.
- upgraded OpenSSL to 0.9.8g

### 2007.10.14 (Ver 2.43)

- added challenge-response(keyboard-interactive) authentication method to auto-login.
  - added "challenge" value to "/auth" command line switch.
- Added the feature to invalidate unsupported method prior to the trial of authentication methods.
  - Added "CheckAuthListFirst" entry in TTSSH section of teraterm.ini. The default value is On.
- Security fix: TeraTerm would temporarily halt server communication for the user confirmation when the server public key tries to add in known_hosts file.
- add support Ctrl+d, Ctrl+k shortcut key in "Host" drop-down on "New connection" dialog. The former is deleting the character at point and the latter is killing the text from point to the end of the line.
- upgraded OpenSSL to 0.9.8f

### 2007.9.30 (Ver 2.42)

- deleted displaying in-use serial port on "New connection" dialog.
- deleted using keyboard-interactive authentication when password authentication is selected. And deleted keyboard-interactive check-box on Authentication Setup dialog. You have to choice "challenge/response" to use keyboard-interactive authentication.
- add support Ctrl+p, Ctrl+n, Ctrl+b, Ctrl+f, Ctrl+a and Ctrl+e shortcut key in "Host" drop-down on "New connection" dialog. Shortcut keys are compatible with up-arrow, down-arrow, left-arrow, right-arrow, Home and End key.
- Bug fix: TCP disconnection was mis-detected in the packet sending.
- replaced internal string functions to secure functions.
  - deleted _CRT_SECURE_NO_DEPRECATE build option.

### 2007.8.8 (Ver 2.41)

- deleted unconditional login retry with password authentication after keyboard-interactive authentication is failure.
- added to disable the serial port in New Connection dialog when there is no available COM ports.
- stopped displaying pop-up error message when port-forward cannot start because already the socket is opening.
- Bug fix: BOF(Buffer Over Flow) problem at the command line parameter.
- Bug fix: disconnected SSH connection when a port-forward connection from remote side is fail.
- Bug fix: socket of SSH channel was not closed when SSH channel cannot open.

### 2007.5.7 (Ver 2.40)

- added parsing double-quoted key filename in the command line parameter.
- Bug fix: When keyboard-interactive authentication enabled with plain password authentication, plain password authentication is displayed with the rhosts authentication in SSH authentication dialog.
- Bug fix: SSH2 port forwarding memory leak when the channel connection is closed.
- Bug fix: TTSSH crashes when new channel is not able to be opened.
- added support for getting the user authentication list on SSH2 connection. TTSSH can try to login with keyboard-interactive method at the first time when the user selected the password authentication.

### 2007.3.10 (Ver 2.39)

- added workaround(WinSock) that send() could have been regarded as success when the return value of send() is minus and the return value of WSAGetLastError() is less than WSABASEERR(10000).
- Moved the focus to passphrase dialog when the user mistook the passphrase of SSH2 private key.
- upgraded OpenSSL to 0.9.8e

### 2007.1.22 (Ver 2.38)

- changed the handling of SSH2_MSG_IGNORE to do nothing. The data from Cisco router seems invalid.
- Bug fix: TCP disconnection was mis-detected in the packet sending.

### 2006.11.20 (Ver 2.37)

- added workaround(SSH_BUG_SIGBLOB) that generating the symmetric key is failure on Extreme Networks switch.

### 2006.11.1 (Ver 2.36)

- Bug fix: Could not connect Tectia server with SSH2 protocol. Changed the timing of both MAC and packet compression method are enabled from user authentication to SSH2_MSG_NEWKEYS procedure.
- Bug fix: Aborted when receiving the stderr data from Tectia server on Windows. Added a procedure for handling SSH2_MSG_CHANNEL_EXTENDED_DATA packet.

### 2006.10.28 (Ver 2.35)

- Bug fix: TTSSH settings wasn't read from ini file which is specified by /F parameter of ttermpro.exe. This bug was introduced in 2.34.
- Bug fix: Couldn't start a telnet session from 'New connection' dialog when main windows is connected with SSH protocol. This bug was introduced in 2.34.
- Bug fix: invalid freeing DH memory in KEX_DH_GRP1_SHA1 or KEX_DH_GRP14_SHA1 sequence.

### 2006.10.09 (Ver 2.34)

- added /ssh1, /ssh2, /telnet command line options.
- added /ask4passwd command line option.
- Bug fix: an error occurs at new connection from a window which is port-forwarding.
- Bug fix: differentiate the case of command line parameter name.
- Bug fix: parse the filename which includes white space.
- upgraded OpenSSL to 0.9.8d

### 2006.9.16 (Ver 2.33)

- added parsing double-quoted filename in the command line parameter.
- Bug fix: Free the user password on heap memory after user authentication.
- upgraded OpenSSL to 0.9.8c

### 2006.8.9 (Ver 2.32)

- Bug fix: Title bar didn't use the small(16x16 dot) icon.

### 2006.8.5 (Ver 2.31)

- added the check-box on SSH authentication dialog whether the user password string would be stored on heap memory. You can configure the its function enabling flag by "RememberPassword" entry of TTSSH section in the 'teraterm.ini' file.

### 2006.7.26 (Ver 2.30)

- updated to new TTSSH icon file(ttsecure.ico). Special thanks to Tatsu Sakamoto.

### 2006.6.29 (Ver 2.29)

- Bug fix: Using SSH2 protocol, changes of the TTSSH setup dialog could not feedback on next ssh session. Special thanks to NAGATA Shinya.
- Bug fix: The 'ssh_known_files' file might not be saved in TeraTerm installation directory. Special thanks to NAGATA Shinya.
- changed Copyright string.

### 2006.6.23 (Ver 2.28)

- added support for SSH2 delayed compression(OpenSSH 4.2 later). Special thanks to NAGATA Shinya.

### 2006.6.14 (Ver 2.27)

- Bug fix: TeraTerm enabled SSH compression could not connect to the server when OpenSSH 4.3 later was configured as delay SSH compression.

### 2006.6.11 (Ver 2.26)

- Bug fix: Alt key was not available for SSH Port Forward dialog. Special thanks to NAGATA Shinya.
- Bug fix: Message box dialog doesn't been quickly shown when TeraTerm does not connect to the server for SSH Port Forward dialog.

### 2006.5.7 (Ver 2.25)

- upgraded OpenSSL to 0.9.8b

### 2006.4.7 (Ver 2.24)

- Bug fix: disconnection of SSH2 protocol after X11 forwarding failure on HP-UX.

### 2006.4.4 (Ver 2.23)

- added the user dialog option that delete the old entry in known_hosts file contains the multiple entries including the different host key type. Special thanks to NAGATA Shinya.

### 2006.3.29 (Ver 2.22)

- Bug fix: application error when known_hosts file contains the multiple entries including the different host key type.

### 2006.3.27 (Ver 2.21)

- added support for known_hosts on SSH2 connection.
- added showing the server's fingerprint on known_hosts dialog.

### 2006.3.6 (Ver 2.20)

- Improved SSH2 communication throughput by changing the window size adjustment.

### 2006.2.24 (Ver 2.19)

- changed the compiler to Visual Studio 2005 Standard Edition.
- replaced stricmp() to _stricmp().
- replaced strdup() to _strdup().
- added support for "command=" in authorized_keys file.
- upgraded OpenSSL to 0.9.8b snapshot

### 2005.10.21 (Ver 2.18)

- added the host history check button on connection dialog.
- upgraded OpenSSL to 0.9.8a

### 2005.9.5 (Ver 2.17)

- added minimizing the SSH authentication dialog with auto-login mode only using '/I' option.

### 2005.8.27 (Ver 2.16)

- added minimizing the SSH authentication dialog with auto-login mode. Special thanks to Tomoo Takahashi.
- upgraded zlib to 1.2.3

### 2005.7.24 (Ver 2.15)

- added support of SSH2 port forwarding
- added support of SSH2 packet compression
- added sending TTY information(VERASE) to server with SSH2 connection.
- Bug fix: The user can't login to the server since the second times when first user authentication is failed with SSH1 protocol.
- Bug fix: The accelerator key(Alt + P or Alt + C) doesn't work on connection dialog.
- upgraded OpenSSL to 0.9.8
- added the security fix(CAN-2005-2096) to zlib 1.2.2

### 2005.5.28 (Ver 2.14)

- added three file filter on private key saving dialog.
- added zlib version information on "About TTSSH" dialog.

### 2005.4.24 (Ver 2.13)

- added SSH key generator dialog(Setup - SSH KeyGenerator).
- upgraded OpenSSL to 0.9.7g

### 2005.4.9 (Ver 2.12)

- added SSH2 channel lookup mechanism for port forwarding.
- fixed the bug of application fault at DH key re-creation (degradation at TTSSH version supporting SSH2 2.10).
- added SSH auto-login with "Duplicate session".

### 2005.3.31 (Ver 2.11)

- added the accelerator key at 'Use challenge/response to log in' on SSH2 authentication dialog.
- added the focus COM input box when you open new connection using COM port.
- added SSH log data(TTSSH.LOG).
- added NetScreen(HITACHI) workaround. Sending SSH2_MSG_CHANNEL_REQUEST message to server is disabled wantconfirm entry.
- upgraded OpenSSL to 0.9.7f

### 2005.3.13 (Ver 2.10)

- upgraded ttxssh.dll version information from 1.5.4 to 2.10.
- changed SSH client ID(SSH-2.0-TTSSH/X.XX Win32) including TTSSH version information.
- added Tru64 UNIX workaround. Special thanks to Miguel.
- added SSH2 dump logging
- fixed the bug of being not able to get rid of CR when CR+LF code is included in SSH server ID.
- changed TTSSH don't send SSH2_MSG_SERVICE_REQUEST to server once the client try to login.
- changed the default value of [TTSSH] KeyboardInteractive to 0(disabled) because SSH connection is closed by server then the invalid method is used in OpenSSH 4.0. And also the password authentication label of SSH authentication dialog is dynamically changed.
- added support of challenge/response login on SSH2 connection.

### 2005.2.22 (Ver 1.09)

- fixed the SSH2 public key problem that TTSSH can't read the private key file in the directory starting by the dot.
- added the configuration of HeartBeat(keep-alive), SSH2 keyboard-interactive on TTSSH setup dialog

### 2005.1.30 (Ver 1.08)

- added support of keyboard-interactive authentication. You can configure the its authentication enabling flag by "KeyboardInteractive" entry of TTSSH section in the 'teraterm.ini' file.
- added show of Project Homepage URL and OpenSSL version at "About TTSSH" dialog.
- fixed the application fault of pushing enter key before be grayed at rhosts and TIS in SSH2 authentication dialog.
- added support of public-key authentication auto-login. And also added /auth=publickey and /keyfile command line option.

### 2005.1.6 (Ver 1.07)

- fixed application fault when changing terminal size on telnet connection (degradation at TTSSH version supporting SSH2 1.06)

### 2005.1.5 (Ver 1.06)

- added support of changing terminal size
- fixed application fault at DH key re-creation (degradation at TTSSH version supporting SSH2 1.05)

### 2004.12.27 (Ver 1.05)

- fixed the bug of can't connect the server after disconnecting when 'Auto window close' function is disabled
- fixed the memory leak of SSH2 KEX procedure
- upgraded the error message string when reading the SSH2 private key is failure

### 2004.12.23 (Ver 1.04)

- added support of public key authentication method

### 2004.12.18 (Ver 1.03)

- added checking HMAC at received packet
- added support of HMAC-MD5 message authentication code
- added verifying the key of RSA and DSA at KEX procedure

### 2004.12.16 (Ver 1.02)

- fixed application fault when using SSH auto-login mode
- fixed application fault when pressing ESC key at "SECURITY WARNING" dialog

### 2004.12.11 (Ver 1.01)

- added support of SSH heartbeat(keep-alive).
  You can configure the heartbeat interval "HeartBeat" entry of TTSSH section in the 'teraterm.ini' file. A measure of heartbeat is per second(default 60 seconds).

### 2004.12.8 (Ver 1.00)

- added support of SSH1/SSH2 auto-login (only password authentication). And also added /auth, /username, /passwd options.
- changed SSH default version to SSH2
- fixed tab order of connection dialog
- changed the focus of connection dialog to host name
- added SSH2 auto-login sample macro(ssh2login.ttl)

### 2004.11.7 (Ver 1.00 beta1)

- added support of encryption algorithm AES128
- added support of KEX algorithm diffie-hellman-group14-sha(OpenSSH 3.9 later version)
- added support of KEX algorithm diffie-hellman-group-exchange-sha1
- added support of server host key algorithm ssh-dss
- added show of SSH2 information in "About TTSSH" dialog
- upgraded OpenSSL to 0.9.7e
- rewrote README(English). Special thanks to Boris Maisuradze for his cooperation.

### 2004.10.25 (Ver 1.00 alpha4)

- fixed the bug of window size control flow
- added support of DH key re-creation after data-communication establishment
- in addition, fine bug fix

### 2004.10.17 (Ver 1.00 alpha3)

- added support of window size control flow
- added send SSH2_MSG_CHANNEL_CLOSE to server on disconnect.
- terminal type is now passed to the environment variable TERM.

### 2004.10.11 (Ver 1.00 alpha2)

- added support of SSH1
- fixed the bug of suddenly disconnecting SSH session (the message "Oversized packet received from server" was appearing in dialog box)
- added /1, /2 command line options
- added SSH protocol version related entry in teraterm.ini file

### 2004.8.8 (Ver 1.00 alpha1a)

- replaced DLL release build version

### 2004.8.5 (Ver 1.00 alpha1)

- first release

## CygTerm+

### v1.07_29 2016/11/26 (by maya)

- Changed the icon image.

### v1.07_28 2016/02/17 (by doda)

- Add debug mode.

### v1.07_27 2016/02/09 (by doda)

- The directory selection by -d option is prior to -cd option(HOME_CHDIR=y).
- When -d option is specified by using -ls option(LOGIN_SHELL=y), CHERE_INVOKING=y is set.

### v1.07_26 2015/12/14 (by doda)

- Add multiple connections support for the ssh-agent proxy.

### v1.07_25 2015/02/21 (by doda)

- Bug fix: The TERM environment variable can not be configured.

### v1.07_24 2013/08/15 (by maya)

- Support for 64bit Cygwin.

### v1.07_23 2011/04/18 (by doda)

- added the error message when the CygTerm can not move the directory specified by -d option.

### v1.07_22 2011/03/03 (by maya)

- Delete mutex object for running check by installer.

### v1.07_21 2011/02/28 (by maya)

- Add mutex object for running check by installer.

### v1.07_20 2010/10/20 (by doda)

- Security fix: A directory move timing delays by using -d option.

### v1.07_19 2010/01/28 (by doda)

- Accept keyword "AUTO" with '-s' option.

### v1.07_18 2010/01/19 (by doda)

- If '-d' option's parameter contains double quote, delete it.

### v1.07_17 2009/06/16 (by doda)

- Added TELNET SGA/ECHO negotiation.

### v1.07_16 2008/11/21 (by doda)

- The option that enables ssh-agent proxy support is changed from '-a' to '-A'.
- Added '-a' option that disables ssh-agent proxy support.

### v1.07_15 2008/11/01 (by doda)

- Added ssh-agent proxy support. Using this feature, a user can access Pageant through CygTerm+.
  - Added '-a' option that enables ssh-agent proxy support.

### v1.07_14 2007/12/17 (by doda)

- Added '-o' option that is specifies additional option for terminal emulator.

### v1.07_13 2007/08/03 (by maya)

- Added '-d' option that is specifies the start directory.

### v1.07_12 2007/06/10 (by doda)

- Add 'SOCKET_TIMEOUT' entry which timeout of waiting telnet connection in cygterm.cfg file.

### v1.07_11 2007/01/31 (import from cygterm v1.07)

- Avoid WinMainCRTStartup() redefinition error with gcc 3.4.
- Give an output gap for keyboard interrupt.

### v1.06_11 2006/09/29 (by maya)

- Stopped using HOME from environment variable and /etc/passwd.
  CygTerm passes HOME which is set by Cygwin. See also /etc/profile
- Changed the priority of config files.
  command line arguments > ~/.cygtermrc > /etc/cygterm.conf > cygterm.cfg > /etc/passwd

### v1.06_10 2006/09/28 (by doda)

- Use getlogin() instead of environment variable USERNAME to get user name.

### v1.06_09 2006/09/25 (by doda)

- Get shell information from /etc/passwd if SHELL parameter is not specified.

### v1.06_08 2006/08/30 (by maya)

- Changed the priority of config files. cygterm.cfg is top priority config file.

### v1.06_07 2006/08/19 (by maya)

- Use `HOME' environment variable for changing home directory if the variable will be set.

### v1.06_06 2006/08/18 (by doda)

- Limit a parameter length of both '-s' and '-t' option.

### v1.06_05 2006/08/18 (by maya)

- Create mutex object for running check by installer.

### v1.06_04 2006/08/15 (by doda)

- Add 'LOGIN_SHELL' entry which the shell is invoked as the login shell in cygterm.cfg file.
  LOGIN_SHELL: yes | no

### v1.06_03 2006/08/15 (by doda)

- Add 'HOME_CHDIR' entry which home directory is changed in cygterm.cfg file.
  HOME_CHDIR: yes | no

### v1.06_02 2006/02/09 (by babydamons@yahoo.co.jp)

- Generated CygTerm's ICON by "DotWork 2.50".
  "DotWork 2.50" is available at http://www5a.biglobe.ne.jp/~suuta/.
  Special Thanks to "suuta at hamal dot freemal dot ne dot jp"
- Makefile was changed, "clean" target was changed to don't remove cygterm.ico.

### v1.06_01 2006/02/08 (by babydamons@yahoo.co.jp)

- Import to TeraTerm Project
- The following configuration file reading was supported:
  - /etc/cygterm.conf
  - ~/.cygtermrc
- Shell is invoked with user's home-directory.
- Get account configuration from /etc/passwd by getpwnam(3),
  getting account name from USERNAME environment by getenv(3).
- Makefile was changed, default build is with icon executable.

### v1.06 2004/01/24

- The following command line options were added:
  - -t 'terminal-emulator' (specifies the terminal emulator)
  - -p port-number (specifies the port# to connect)
  - -dumb (specifies dumb terminal mode)
  - -s 'shell' (specifies the shell)
  - -v 'env-var' (specifies environment variables)
- Makefile was changed.
  - Fixed to fail in `make install' if BINDIR was not found.
- cygterm.cc and README.txt were changed to English version.

### v1.05 2003/01/14

- Fixed to transmit Ctrl+SPACE (NUL).
  The NUL character was not able to be transmitted even if Ctrl+SPACE was typed, because it was ignored simply as an way to handle the newline CR+NUL.

### v1.04 2002/12/08

- Changed to display error messages for failure to execute a terminal emulator or a shell.
- Makefile was changed.
  - do not overwrite cygterm.cfg when `make install'.
  - add the gcc option -fno-exceptions against the GCC-3 link error.

### v1.03 2002/07/24

- Fixed to convert terminal type into lower-case when cygterm received it from a terminal emulator.
  Because some upper-case values such as `ANSI' `VT100' of the environment variable TERM might not be found in terminfo depending on the kind of terminal emulator. (Windows 2000 telnet.exe, etc)

### v1.02 2002/07/22

- Fix to be able to start a terminal emulator even if it was a console application. (Windows 2000 telnet.exe, etc)
  There was a mistake in calling CreateProcess().
- Fixed to suppress duplicate newline on a shell by canceling LF when a terminal emulator sent CR+LF. (Windows 98 telnet.exe, etc)
- Embedded the version number in cygterm.exe executable code.
  How to check: $ strings cygterm.exe | grep version

### v1.01 2002/07/19

- Fixed that cygterm did not work with zsh or tcsh. Input was blocked when zsh or tcsh started, because the approach to open the pseudo terminal was not good.

### v1.00 2000/12/17

- The initial version was released.

## cyglaunch

### 2011.6.26 (Ver 1.03)

- The CygTerm Here does not work well for the root directory.
- The CygTerm Here does not work well for the UNC path.

### 2010.12.7 (Ver 1.02)

- Security fix: The current directory changes to the cyglaunch.exe existing directory, and launches the cygterm.exe program.

### 2009.3.22 (Ver 1.01)

- Bug fix: PATH environment variable is truncated to 1024 bytes.

### 2007.8.8 (Ver 1.00)

- First release.

## TTProxy

### 2019.12.7 (Ver 1.0.0.26)

- Bug fixes
  - When the HTTP proxy connection fails and the status code is other than 400,401,403,405,406,407, invalid string is shown in the message box.

### 2019.08.31 (Ver 1.0.0.25)

- Changes
  - When the negotiation is failed with SOCKS4 and 5, an error information is added to message.
- Bug fixes
  - Bug fix: Depending on OS, setup dialog is not working correctly. This bug was introduced in 4.103.
  - Bug fix: When the hostname setting is domain, IPv6 and IPv4 fallback does not work well. And also, when you can not connect to the proxy server, Connection refused dialog is shown three times in a row.
  - Bug fix: When data can not receive from SOCKS server during negotiation with SOCKS4 and 5, the data may not be handled as an error.

### 2016.11.30 (Ver 1.0.0.24)

- When an authentication is used on HTTP proxy, Tera Term(TTProxy) will be crashed.
- When an authentication is used on HTTP proxy, the authentication does not be encoded with base64 protocol.
- The HTTP proxy connection is changed from HTTP/1.0 to HTTP/1.1.

### 2016.08.31 (Ver 1.0.0.23)

- The `-noproxy' option is added at command line. The function is same as `-proxy=none://' option that is disabled proxy configuration.
- The priority(order) of loading TTX plugin is changed from 0 to 10.

### 2015.12.01 (Ver 1.0.0.22)

- The command line option can be quoted from an offset when the '"' is used.

### 2015.05.31 (Ver 1.0.0.21)

- The /F= command option can be read earlier than other option.

### 2014.06.01 (Ver 1.0.0.20)

- The language file may not be reflected.
- The SSL-type proxy type can not be shown because the feature can not work well.

### 2014.02.28 (Ver 1.0.0.19)

- Bug fix: The command line parameter including space character can not be recognized well.

### 2011.3.5 (Ver 1.0.0.18)

- added support for IPv6.
  - Bug fix: The IPv6 address can not be specified at the proxy server.
  - Bug fix: Tera Term can not connect the proxy server with the IPv6 address by the IPv6 protocol.
  - Bug fix: Tera Term can not connect the IPv6 host by using the SOCK5 proxy protocol.
- change the timing of the name resolution.
  - Bug fix: Tera Term can not connect the host not resolving the domain name by using the HTTP/TELNET proxy protocol.
  - Bug fix: Tera Term will try to resolve the domain name by mistake despite the SOCKS proxy connection.

### 2010.12.7 (Ver 1.0.0.17)

- Bug fix: When the port number is specified by the five-figure numeric, the application fault would occur.

### 2009.11.10 (Ver 1.0.0.16)

- Bug fix: teraterm didn't connect to server in some cases because of failed to parse a command line parameters.
  changes of version 1.0.0.13 were incomplete.

### 2008.2.29 (Ver 1.0.0.15)

- Bug fix: The port number over 32767 could not be available for proxy connection.
- Bug fix: couldn't close "Setup dialog" by OK button without host name when the type of proxy is NONE.

### 2007.9.30 (Ver 1.0.0.14)

- added support for dynamic loading of user interface messages.

### 2007.5.7 (Ver 1.0.0.13)

- "protocol://<user<:password>@>proxyserver:proxyport" style parameter became unsupported.
  This style conflicts with TeraTerm parameter style "telnet://server<:port>".

### 2007.3.8 (Ver 1.0.0.12)

- fix bug: Japanese resource was used with Windows that is not English.

### 2007.2.6 (Ver 1.0.0.11)

- fix bug: url decode/encode was broken.
  teraterm didn't connect to the proxy server via "New connection" dialog, when host/user/pass are included out of [-\.0-9A-Z_a-z].

### 2006.12.12 (Ver 1.0.0.10)

- deleted SetThreadLocale with the language which is detected from TeraTerm dialog resource.

### 2006.11.23 (Ver 1.0.0.9)

- Bug fix: didn't respond when the style of TearTerm command line parameter is "telnet://host."
  returns the control to TeraTerm if proxy port number is 0.

### 2006.8.1 (Ver 1.0.0.8)

- imported the source with permission of original author Yebisuya Sugoroku.

## TeraTerm Menu

### 2023.10.15 (Ver 1.17)

- TeraTerm Menu can pass an argument that is over 260 bytes to ttermpro.exe now.

### 2021.6.5 (Ver 1.16)

- The tool chip's text of button for registering to the list are changed to "Register" and "Unregister".
- Bug fix: The extra "\" character is displayed on the version information.

### 2017.11.30 (Ver 1.15)

- When the ttpmenu.ini file is used, the buffer size including whole host setting name is expanded from 2.6KB to 10KB.

### 2016.11.30 (Ver 1.14)

- Updated the TeraTerm icon(teraterm.ico).

### 2015.05.31 (Ver 1.13)

- When the filename and password value contains a semicolon(;) on SSH connection, the semicolon can not be quoted.

### 2014.08.31 (Ver 1.12)

- Bug fix: A program icon in the notification area may not be displayed.

### 2011.12.04 (Ver 1.11)

- added support for inputing the control character(^A-^_) as the password.

### 2011.6.26 (Ver 1.10)

- Bug fix: Icon resource does not be released.

### 2009.7.5 (Ver 1.09)

- added support for changing TTSSH command line specification.

### 2008.6.25 (Ver 1.08)

- added support for Pageant.
- updated to new TeraTerm icon file(teraterm.ico). Special thanks to Tatsu Sakamoto.

### 2007.12.4 (Ver 1.07)

- added support for saving TeraTerm Menu configuration from registry to ini file. Touch "ttpmenu.ini" file in "ttpmenu.exe" installation directory when you want to use ini file. However, re-register your configuration manually because the registry database will not be migrated to the ini file. Special thanks to Matsumoto Hiroki.
- added support for keyboard-interactive authentication(/challenge).
- Bug fix: extension filters on file dialog didn't work when a message file does not exist.
- Bug fix: application could not start when the application is specified by relative path.

### 2007.9.30 (Ver 1.06)

- added support for dynamic loading of user interface messages.

### 2007.3.10 (Ver 1.05)

- Bug fix: pop-up menu was displayed at invalid position on Windows Vista.

### 2006.2.24 (Ver 1.04)

- fixed build error with VS2005.

### 2005.1.30 (Ver 1.03)

- Bug fix: TeraTerm Menu pop-up menu couldn't be shown at right position using multi monitor system.

### 2005.1.30 (Ver 1.02)

- added Kanji code(/KT=UTF8 /KR=UTF8) of default option
- added specify of user parameter at SSH auto-login
- deleted macro specification at SSH auto-login
- added specify of private-key-file at SSH auto-login

### 2004.12.14 (Ver 1.01)

- Changed the initial folder path of ttermpro.exe to current directory.

### 2004.12.8 (Ver 0.94r2)

- added TeraTerm Menu 0.94r2(+SSH2 support 1.00). It is thankful to Shinpei Hayakawa.

## TTX KanjiMenu

### 2021.6.5 (Ver 0.1.8)

- UTF-8m setting does not shown in Korean mode.

### 2016.11.30 (Ver 0.1.7)

- When Kanji code is changed, internal status regarding Kanji code of Tera Term core is cleared.

### 2009.7.5 (Ver 0.1.6)

- added support when the setting of Language is Korean.

### 2009.3.22 (Ver 0.1.5)

- added support for changing concurrently both the Recv and the Send.
  - added the UseOneSetting entry in the teraterm.ini file. The default value is off.
- Bug fix: The menu can not display on Windows 95.

### 2008.2.29 (Ver 0.1.4)

- Big fix: couldn't select "Recv: UTF-8m"

### 2007.8.8 (Ver 0.1.3)

- linked to LIBCMT.LIB statically for Win98, Me and NT4.0.
- added checking the valid range to set KanjiCode in shared variable numbers.
- menu is displayed only when the setting of Language is Japanese.

### 2007.5.25 (Ver 0.1.2)

- imported the source with permission of original author Sunao HARA.

## TTXAlwaysOnTop

### 2009.7.5 (Ver 1.01)

- added support for dynamic loading of user interface messages.

### 2008.12.16 (Ver 1.00)

- first release

## TTXKCodeChange

### 2013.02.28 (Ver 1.01)

- added support for the control sequence to push/pop settings on stack.
- When the sequence is continuing, a rear sequence will be not worked.

### 2008.12.16 (Ver 1.00)

- first release

## TTXResizeMenu

### 2022.10.15 (Ver 1.07)

- added support for Tera Term 5.0.
- Fixed an issue when Tera Term is not connected to host, an application fault occurs.

## TTXResizeMenu

### 2019.12.7 (Ver 1.06)

- Fixed the access key for the 16th and subsequent entries in the menu.

### 2018.11.30 (Ver 1.05)

- added menu id to increase/decrease window size. (for shortcut keys)

### 2018.08.31 (Ver 1.04)

- Fixed an issue where TTXResizeMenu can not be loaded on Windows 95/NT4.0.
- Fixed an issue where TTXResizeMenu is not display on menu on Windows 95/98/Me/NT4.0.

### 2014.08.31 (Ver 1.03)

- The maximum size of the screen width and height can be specified as the menu entry.

### 2013.02.28 (Ver 1.02)

- increased max height of window from 200 lines to 500 lines.

### 2010.2.10 (Ver 1.01)

- Deleted the default menu.

### 2008.12.16 (Ver 1.00)

- first release

## TTXttyrec

### 2023.10.15 (Ver 1.05)

- Fixed [Replay again] is not working when playing from command line.
- added support for playing tty file while another Tera Term is playing same tty file

### 2019.12.7 (Ver 1.04)

- Bug fix: Unexpected pauses and playback speed changes occur when replaying the editing by Vim.

### 2017.02.28 (Ver 1.03)

- added [Replay again] entry under [File] menu that can replay again after one relaying.

### 2010.2.20 (Ver 1.02)

- changed the default value of "RecordStartSize" to On.

### 2009.7.5 (Ver 1.01)

- added support for displaying the replay speed on the window title. Special thanks to peterprvy.
- added no-wait mode.
  - added the /ttyplay-nowait command line option.
- added support for recording the current window size when recording is started. It is recorded as the window size change control sequence.
  - added the RecordStartSize entry in the teraterm.ini file. The default is off.
- Bug fix: Replay speed changing doesn't work correctly. Special thanks to peterprvy.
- Bug fix: Can't replay large data segment correctly.

### 2008.12.16 (Ver 1.00)

- first release

## TTXViewMode

### 2008.12.16 (Ver 1.00)

- first release

## TTXRecurringCommand

### 2016.11.30 (Ver 1.05)

- added new configuration that carriage return can add at end of sending command.

### 2015.12.01 (Ver 1.04)

- The command line option can be quoted from an offset when the '"' is used.

### 2013.11.30 (Ver 1.03)

- Expanded the command buffer size from 50 byte to 1024 byte.

### 2011.12.04 (Ver 1.02)

- added the menu id to enable and disable for the macro command.
- added support for the reading the configuration file by using the /F= option.

### 2010.2.10 (Ver 1.01)

- Changed the minimum value of the sending interval from 10 to 1 second.
- added support for switching directly the enabling and disabling by the control menu.
- added support for dynamic loading of user interface messages.

### 2009.6.30 (Ver 1.00)

- first release